/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { BollingerBandWidthIndicatorStrategy } from "./BollingerBandWidthIndicatorStrategy";
import { typeGetValue, markType } from "./type";
export class BollingerBandWidthIndicator extends StrategyBasedIndicator {
    get_pp() {
        return new BollingerBandWidthIndicatorStrategy();
    }
    get pp() {
        return this.get_pp();
    }
    get_p2() {
        return BollingerBandWidthIndicator.$;
    }
    get p2() {
        return this.get_p2();
    }
    get qb() {
        return typeGetValue(this.c(BollingerBandWidthIndicator.qe));
    }
    set qb(a) {
        this.h(BollingerBandWidthIndicator.qe, a);
    }
    pv() {
        return this.qb;
    }
    get qa() {
        return this.c(BollingerBandWidthIndicator.qd);
    }
    set qa(a) {
        this.h(BollingerBandWidthIndicator.qd, a);
    }
    pt() {
        return this.qa;
    }
}
BollingerBandWidthIndicator.qe = StrategyBasedIndicator.p7(20, BollingerBandWidthIndicator.$);
BollingerBandWidthIndicator.qd = StrategyBasedIndicator.p6(2, BollingerBandWidthIndicator.$);
BollingerBandWidthIndicator.$t = markType(BollingerBandWidthIndicator, 'BollingerBandWidthIndicator', StrategyBasedIndicator.$);
/*<BeginStatics Name="Infragistics.Controls.Charts.BollingerBandWidthIndicator" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.BollingerBandWidthIndicator" />*/
//# sourceMappingURL=BollingerBandWidthIndicator.js.map