/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { BaseDOMEventProxy } from "./BaseDOMEventProxy";
import { TypeRegistrar, runOn, delegateCombine, Point_$type, String_$type, Delegate_$type, Number_$type, markType } from "./type";
import { Dictionary$2 } from "./Dictionary$2";
import { List$1 } from "./List$1";
import { TouchPointInfo } from "./TouchPointInfo";
import { DOMExecutionContext } from "./DOMExecutionContext";
import { TouchGestureRecognizer } from "./TouchGestureRecognizer";
export class CanvasGestureDOMEventProxy extends BaseDOMEventProxy {
    constructor(a, b) {
        super();
        this.c2 = 0;
        this.c3 = "";
        this.cp = null;
        this.c0 = null;
        this.cv = new Dictionary$2(String_$type, List$1.$.specialize(Delegate_$type), 0);
        this.dr = null;
        this.cq = false;
        this.cw = new List$1(Number_$type, 0);
        this.cx = new List$1(Point_$type, 0);
        this.cy = new List$1(TouchPointInfo.$, 0);
        this.bo = b;
        this.cp = new TouchGestureRecognizer(new DOMExecutionContext(b));
        let c = this.cp;
        c.holdEnding = delegateCombine(c.holdEnding, runOn(this, this.c5));
        let d = this.cp;
        d.holdStarting = delegateCombine(d.holdStarting, runOn(this, this.c6));
        let e = this.cp;
        e.zoomStarting = delegateCombine(e.zoomStarting, runOn(this, this.dd));
        let f = this.cp;
        f.zoomEnding = delegateCombine(f.zoomEnding, runOn(this, this.dc));
        let g = this.cp;
        g.panStarting = delegateCombine(g.panStarting, runOn(this, this.db));
        let h = this.cp;
        h.panEnding = delegateCombine(h.panEnding, runOn(this, this.da));
        let i = this.cp;
        i.manipulationStarting = delegateCombine(i.manipulationStarting, runOn(this, this.c9));
        let j = this.cp;
        j.manipulationChanging = delegateCombine(j.manipulationChanging, runOn(this, this.c7));
        let k = this.cp;
        k.manipulationEnding = delegateCombine(k.manipulationEnding, runOn(this, this.c8));
        let l = this.cp;
        l.doubleTapped = delegateCombine(l.doubleTapped, runOn(this, this.c4));
        let m = this.cp;
        m.flingStarting = delegateCombine(m.flingStarting, runOn(this, this.cr));
        this.ai = (n) => true;
        this.z = true;
        CanvasGestureDOMEventProxy.c1++;
        this.c2 = CanvasGestureDOMEventProxy.c1;
        this.c3 = ".DOMProxy" + this.c2.toString();
        this.a7 = 0;
        this.bp = a;
        BaseDOMEventProxy.bh = false;
        try {
            BaseDOMEventProxy.bh = (window.navigator.msPointerEnabled && MSGesture !== undefined);
        }
        catch (n) {
        }
        BaseDOMEventProxy.bi = false;
        try {
            BaseDOMEventProxy.bi = (window.PointerEvent || window.navigator.pointerEnabled);
        }
        catch (o) {
        }
        if (BaseDOMEventProxy.bh || BaseDOMEventProxy.bi) {
            this.z = false;
        }
        BaseDOMEventProxy.bx = this.bw();
        BaseDOMEventProxy.bu = this.bv();
        this.ak(this.bp, "");
        this.ah = (p) => true;
    }
    d() {
        let a = new CanvasGestureDOMEventProxy(this.bp, this.bo);
        a.z = this.z;
        a.ai = this.ai;
        return a;
    }
    cr(a, b) {
        return this.ab({ $type: Point_$type, x: b.a, y: b.b }, b.h, b.i);
    }
    c4(a, b) {
        this.aq({ $type: Point_$type, x: b.a, y: b.b });
    }
    get_ag() {
        return true;
    }
    get ag() {
        return this.get_ag();
    }
    c8(a, b) {
        if (this.cp.n == 0) {
            this.au({ $type: Point_$type, x: b.a, y: b.b }, b.d);
            this.cb();
        }
    }
    c7(a, b) {
        if (this.cp.n == 2) {
            this.a1({ $type: Point_$type, x: b.a, y: b.b }, b.d);
            this.a4({ $type: Point_$type, x: b.a, y: b.b }, b.d, b.e, b.c);
        }
        if (this.cp.n == 1 || this.cp.n == 5) {
            this.ao({ $type: Point_$type, x: b.a, y: b.b }, true);
            this.as({ $type: Point_$type, x: b.a, y: b.b });
        }
    }
    c9(a, b) {
    }
    da(a, b) {
        this.cq = false;
        if (this.cp.n == 0) {
            this.an({ $type: Point_$type, x: b.a, y: b.b }, true);
            this.ar({ $type: Point_$type, x: b.a, y: b.b });
        }
    }
    db(a, b) {
        this.at({ $type: Point_$type, x: b.a, y: b.b });
    }
    dc(a, b) {
        this.a3({ $type: Point_$type, x: b.a, y: b.b }, b.d, b.e, b.c);
    }
    dd(a, b) {
        this.a2({ $type: Point_$type, x: b.a, y: b.b }, 1);
        this.a5({ $type: Point_$type, x: b.a, y: b.b }, 1, 1, 1);
    }
    c6(a, b) {
        this.cq = true;
        this.av({ $type: Point_$type, x: b.a, y: b.b });
    }
    c5(a, b) {
        if (this.cp.n == 0) {
            this.an({ $type: Point_$type, x: b.a, y: b.b }, true);
        }
    }
    static ct() {
        BaseDOMEventProxy.bh = false;
        try {
            BaseDOMEventProxy.bh = (window.navigator.msPointerEnabled && MSGesture !== undefined);
        }
        catch (a) {
        }
        BaseDOMEventProxy.bi = false;
        try {
            BaseDOMEventProxy.bi = (window.PointerEvent || window.navigator.pointerEnabled);
        }
        catch (b) {
        }
        return BaseDOMEventProxy.bh || BaseDOMEventProxy.bi;
    }
    de(a, b, c) {
    }
    ak(a, b) {
        let c = a;
        if (!this.bo.supportsDOMEvents()) {
            return;
        }
        let d = this.c3 + b;
        let e = new List$1(Delegate_$type, 0);
        this.cv.addItem(d, e);
        this.de(a, b, e);
        if (!BaseDOMEventProxy.bh && !BaseDOMEventProxy.bi) {
            e.add(c.listen("mousemove", runOn(this, this.b4)));
            e.add(c.listen("mouseleave", runOn(this, this.b3)));
            e.add(c.listen("mousedown", runOn(this, this.b2)));
            e.add(c.listen("mouseup", runOn(this, this.b6)));
            e.add(this.bo.globalListen("window", "mouseup", runOn(this, this.cj)));
        }
        e.add(c.listen("keydown", runOn(this, this.bz)));
        e.add(c.listen("keyup", runOn(this, this.b1)));
        if (BaseDOMEventProxy.bh || BaseDOMEventProxy.bi) {
            let source_ = this.bp.getNativeElement();
            BaseDOMEventProxy.cd(source_);
            let f = this.bp.getNativeElement();
            if (BaseDOMEventProxy.bi) {
                e.add(c.listen("pointerdown", runOn(this, this.dh)));
                e.add(c.listen("pointerup", runOn(this, this.dk)));
                e.add(c.listen("pointercancel", runOn(this, this.dg)));
                e.add(c.listen("pointermove", runOn(this, this.di)));
                e.add(c.listen("pointerout", runOn(this, this.dj)));
                e.add(c.listen("lostpointercapture", runOn(this, this.df)));
            }
            else {
                e.add(c.listen("MSPointerDown", runOn(this, this.dh)));
                e.add(c.listen("MSPointerUp", runOn(this, this.dk)));
                e.add(c.listen("MSPointerCancel", runOn(this, this.dg)));
                e.add(c.listen("MSPointerMove", runOn(this, this.di)));
                e.add(c.listen("MSPointerOut", runOn(this, this.dj)));
                e.add(c.listen("MSLostPointerCapture", runOn(this, this.df)));
            }
        }
        e.add(c.listen("DOMMouseScroll", runOn(this, this.b5)));
        e.add(c.listen("mousewheel", runOn(this, this.b5)));
        e.add(c.listen("touchstart", runOn(this, this.dn)));
        e.add(c.listen("touchmove", runOn(this, this.dm)));
        e.add(c.listen("touchend", runOn(this, this.dl)));
    }
    dk(e_) {
        let a = this.cs(e_);
        let b = this.cw.indexOf((e_.originalEvent.pointerId));
        if (b >= 0) {
            this.cw.removeAt(b);
            this.cx.removeAt(b);
            this.bt = this.cw.count;
        }
        if (a) {
            this.dl(e_);
        }
        else {
            this.b6(e_);
        }
    }
    df(e_) {
        let a = this.cs(e_);
    }
    dg(e_) {
        let a = this.cs(e_);
        let b = this.cw.indexOf((e_.originalEvent.pointerId));
        if (b >= 0) {
            this.cw.removeAt(b);
            this.cx.removeAt(b);
            this.bt = this.cw.count;
        }
    }
    dh(e_) {
        let a = this.cs(e_);
        BaseDOMEventProxy.cc(e_);
        this.cw.add((e_.originalEvent.pointerId));
        this.cx.add({ $type: Point_$type, x: e_.pageX, y: e_.pageY });
        this.bt = this.cw.count;
        if (a) {
            this.ci(e_);
        }
        else {
            this.ch(e_);
        }
        this.cg(e_);
        if (this.ah(this.cn)) {
            let eventSource_ = this.bp.getNativeElement();
            if (BaseDOMEventProxy.bi) {
                eventSource_.setPointerCapture(e_.originalEvent.pointerId);
            }
            else {
                eventSource_.msSetPointerCapture(e_.originalEvent.pointerId);
            }
        }
        if (a) {
            this.dn(e_);
        }
        else {
            this.b2(e_);
        }
    }
    cs(e_) {
        let pointerEvent_ = e_.originalEvent;
        let a = false;
        if (BaseDOMEventProxy.bi) {
            a = (pointerEvent_.pointerType == 'touch');
        }
        else {
            a = (pointerEvent_.pointerType == pointerEvent_.MSPOINTER_TYPE_TOUCH);
        }
        return a;
    }
    di(e_) {
        let a = this.cs(e_);
        BaseDOMEventProxy.cc(e_);
        let b = this.cw.indexOf((e_.originalEvent.pointerId));
        if (b >= 0) {
            this.cx._inner[b] = { $type: Point_$type, x: e_.pageX, y: e_.pageY };
        }
        if (a) {
            this.dm(e_);
        }
        else {
            this.b4(e_);
        }
    }
    dj(e_) {
        let a = this.cs(e_);
        if (a) {
        }
        else {
            this.b3(e_);
        }
    }
    dn(e_) {
        this.bg = true;
        this.cg(e_);
        this.ci(e_);
        this.dr = this.cm;
        if (this.ah(this.cn)) {
            if (!this.z || this.bt > 1) {
                if (this.bj) {
                    this.bj = false;
                    this.by();
                }
                this.ce(e_);
            }
            else {
                this.bj = true;
                this.cq = false;
            }
            this.az(this.cn, false, true);
            this.aw(this.cn);
            this.ap(this.cm, true);
            this.cp.a6(this.cz(e_));
        }
    }
    cz(e_) {
        let a = BaseDOMEventProxy.co(this.bp);
        let b = this.ba;
        this.cy.clear();
        if (BaseDOMEventProxy.bh || BaseDOMEventProxy.bi) {
            let c = this.cw.count;
            for (let j_ = 0; j_ < c; j_++) {
                let d = this.cw._inner[j_];
                let e = this.cx._inner[j_];
                let f = e.x;
                let g = e.y;
                let h = new TouchPointInfo(1);
                h.a = (f - a.left) - b.left;
                h.b = (g - a.top) - b.top;
                this.cy.add(h);
            }
        }
        else {
            let i = (e_.originalEvent.targetTouches.length);
            for (let j_ = 0; j_ < i; j_++) {
                let j = (e_.originalEvent.targetTouches[j_].pageX);
                let k = (e_.originalEvent.targetTouches[j_].pageY);
                let l = new TouchPointInfo(1);
                l.a = (j - a.left) - b.left;
                l.b = (k - a.top) - b.top;
                this.cy.add(l);
            }
        }
        return this.cy;
    }
    dm(a) {
        this.bg = true;
        this.cg(a);
        this.ci(a);
        if (this.bj) {
            if ((this.ah(this.cn) && this.cu()) || this.cq == true || this.cp.n == 2) {
                this.bj = false;
                this.by();
            }
        }
        if ((this.cq || this.cp.n == 2 || this.ah(this.cn)) && !this.bj) {
            this.cq = true;
            this.ce(a);
            this.cp.a6(this.cz(a));
        }
    }
    cu() {
        let a = { $type: Point_$type, x: this.dr.x - this.cm.x, y: this.dr.y - this.cm.y };
        if (Math.abs(a.x) > Math.abs(a.y)) {
            a.y = 0;
        }
        if (Math.abs(a.y) > Math.abs(a.x)) {
            a.x = 0;
        }
        return this.ai(a);
    }
    dl(a) {
        this.bg = false;
        this.cg(a);
        this.ci(a);
        if (this.bj) {
            this.bj = false;
            this.by();
        }
        let b = this.cp.n;
        let c = this.ah(this.cn) || b != 0;
        if (this.cp.n != 2 && this.cp.n != 5) {
            this.az(this.cn, false, true);
            this.a0(this.cn);
        }
        let d = this.cp.n == 2;
        if (d) {
            c = true;
            this.an({ $type: Point_$type, x: this.cp.as, y: this.cp.at }, true);
        }
        this.cp.a6(this.cz(a));
        if (this.cp.n == 0) {
            this.cb();
        }
        if (!d && this.cp.n == 0) {
            this.an({ $type: Point_$type, x: this.cp.as, y: this.cp.at }, true);
        }
        if (this.cp.n != 0) {
            c = true;
        }
        if (c) {
            this.ce(a);
        }
    }
    dp(a) {
        if (this.cv.containsKey(a)) {
            let b = this.cv.item(a);
            this.cv.removeItem(a);
            for (let c = 0; c < b.count; c++) {
                b._inner[c]();
            }
            b.clear();
        }
    }
    a6(a, b) {
        let c = a;
        let d = this.c3 + b;
        this.dp(d);
    }
    al() {
        if (this.bp == null) {
            return;
        }
        this.dp(this.c3);
        this.bp = null;
    }
    static register() {
        TypeRegistrar.register("CanvasGestureDOMEventProxy", CanvasGestureDOMEventProxy.$);
    }
}
CanvasGestureDOMEventProxy.c1 = 0;
CanvasGestureDOMEventProxy.$t = markType(CanvasGestureDOMEventProxy, 'CanvasGestureDOMEventProxy', BaseDOMEventProxy.$);
/*<BeginStatics Name="Infragistics.Controls.CanvasGestureDOMEventProxy" />*/
/*<EndStatics Name="Infragistics.Controls.CanvasGestureDOMEventProxy" />*/
//# sourceMappingURL=CanvasGestureDOMEventProxy.js.map