/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { CustomIndicatorStrategy } from "./CustomIndicatorStrategy";
import { String_$type, fromEnum, markType } from "./type";
import { FinancialEventArgs } from "./FinancialEventArgs";
import { List$1 } from "./List$1";
export class CustomIndicator extends StrategyBasedIndicator {
    constructor() {
        super(...arguments);
        this.qb = null;
        this.qa = null;
    }
    get_pp() {
        return new CustomIndicatorStrategy();
    }
    get pp() {
        return this.get_pp();
    }
    get_p2() {
        return CustomIndicator.$;
    }
    get p2() {
        return this.get_p2();
    }
    o1(a, b) {
        let c = this.lz(a, b);
        let d = this.l0(c);
        let e = new List$1(String_$type, 0);
        if (this.qa != null) {
            let f = new FinancialEventArgs(c.calculateFrom, c.calculateCount, c, d, this);
            this.qa(this, f);
            if (f.basedOn != null) {
                for (let g of fromEnum(f.basedOn)) {
                    e.add(g);
                }
            }
        }
        return e;
    }
    get indicator() {
        return this.qb;
    }
    set indicator(a) {
        this.qb = a;
        this.o9();
    }
    get basedOnColumns() {
        return this.qa;
    }
    set basedOnColumns(a) {
        this.qa = a;
    }
    oy(a, b) {
        super.oy(a, b);
        if (this.qb != null) {
            let c = this.lz(a, b);
            if (b == 0) {
                return false;
            }
            if (!this.mu(this.o1(a, b))) {
                return false;
            }
            this.qb(this, new FinancialEventArgs(a, b, c, this.l0(c), this));
            if (this.pr(c) && this.l7 != null) {
                this.l7.cb();
            }
            return true;
        }
        return false;
    }
}
CustomIndicator.$t = markType(CustomIndicator, 'CustomIndicator', StrategyBasedIndicator.$);
//# sourceMappingURL=CustomIndicator.js.map