import { IVisualData } from "./IVisualData";
import { RectData } from "./RectData";
import { List$1 } from "./List$1";
import { PointData } from "./PointData";
import { GetPointsSettings } from "./GetPointsSettings";
import { Base, Type } from "./type";
export declare abstract class GeometryData extends Base implements IVisualData {
    readonly abstract type: string;
    abstract scaleByViewport(a: RectData): void;
    abstract getPointsOverride(a: List$1<List$1<PointData>>, b: GetPointsSettings): void;
    serialize(): string;
    protected a(): string;
    static $t: Type;
}
