/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { SlowStochasticOscillatorIndicatorStrategy } from "./SlowStochasticOscillatorIndicatorStrategy";
import { typeGetValue, markType } from "./type";
import { Brush } from "./Brush";
export class SlowStochasticOscillatorIndicator extends StrategyBasedIndicator {
    constructor() {
        super();
        this.trendLineBrush = ((() => {
            let $ret = new Brush();
            $ret.fill = "#565656";
            return $ret;
        })());
        this.trendLineType = 10;
        this.trendLinePeriod = 3;
    }
    get_pp() {
        return new SlowStochasticOscillatorIndicatorStrategy();
    }
    get pp() {
        return this.get_pp();
    }
    get_p2() {
        return SlowStochasticOscillatorIndicator.$;
    }
    get p2() {
        return this.get_p2();
    }
    get qa() {
        return typeGetValue(this.c(SlowStochasticOscillatorIndicator.qb));
    }
    set qa(a) {
        this.h(SlowStochasticOscillatorIndicator.qb, a);
    }
    pv() {
        return this.qa;
    }
    p4(a) {
        this.qa = a;
    }
}
SlowStochasticOscillatorIndicator.qb = StrategyBasedIndicator.p7(14, SlowStochasticOscillatorIndicator.$);
SlowStochasticOscillatorIndicator.$t = markType(SlowStochasticOscillatorIndicator, 'SlowStochasticOscillatorIndicator', StrategyBasedIndicator.$);
/*<BeginStatics Name="Infragistics.Controls.Charts.SlowStochasticOscillatorIndicator" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.SlowStochasticOscillatorIndicator" />*/
//# sourceMappingURL=SlowStochasticOscillatorIndicator.js.map