import { HorizontalAnchoredCategorySeries } from "./HorizontalAnchoredCategorySeries";
import { IIsCategoryBased } from "./IIsCategoryBased";
import { CategoryLineRasterizer } from "./CategoryLineRasterizer";
import { CategoryMode } from "./CategoryMode";
import { SeriesView } from "./SeriesView";
import { Type, IList$1 } from "./type";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { CategoryFrame } from "./CategoryFrame";
import { List$1 } from "./List$1";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { CategorySeriesView } from "./CategorySeriesView";
import { Path } from "./Path";
import { PointCollection } from "./PointCollection";
import { UnknownValuePlotting } from "./UnknownValuePlotting";
import { AnchoredCategorySeriesView } from "./AnchoredCategorySeriesView";
import { Clipper } from "./Clipper";
import { RenderingContext } from "./RenderingContext";
export declare class StepAreaSeries extends HorizontalAnchoredCategorySeries implements IIsCategoryBased {
    protected be(): SeriesView;
    h9(a: SeriesView): void;
    px: StepAreaSeriesView;
    protected get_ci(): boolean;
    readonly ci: boolean;
    constructor();
    pw: CategoryLineRasterizer;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    he(a: boolean, b: SeriesView): void;
    private py(a, b, c, d, e);
    protected mv(): CategoryTransitionInMode;
    d6(a: number, b: IList$1<number>, c: number, d: number, e: number, f: number, g: number, h: boolean): number;
    protected bc(): SeriesHitTestMode;
    n2(a: CategoryFrame, b: CategorySeriesView): void;
    readonly currentCategoryMode: CategoryMode;
    readonly useHighMarkerFidelity: boolean;
    static $t: Type;
}
export declare class StepAreaSeriesView extends AnchoredCategorySeriesView {
    protected c4: StepAreaSeries;
    constructor(a: StepAreaSeries);
    ap(): void;
    private dc;
    private dg;
    private de;
    private di;
    readonly dd: Path;
    readonly dh: Path;
    readonly df: Path;
    readonly dj: Path;
    c5(): void;
    c6(a: number, b: List$1<number[]>, c: boolean, d: number, e: number, f: (arg1: PointCollection, arg2: PointCollection, arg3: PointCollection, arg4: PointCollection, arg5: boolean) => void, g: UnknownValuePlotting): void;
    c7(a: number, b: List$1<number[]>, c: boolean, d: number, e: number, f: (arg1: PointCollection, arg2: PointCollection, arg3: PointCollection, arg4: PointCollection, arg5: boolean) => void, g: UnknownValuePlotting, h: Clipper): void;
    private c8;
    private da;
    private c9;
    private db;
    protected a9(): void;
    protected a3(a: RenderingContext, b: boolean): void;
    ai(a: any): void;
    static $t: Type;
}
