import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { IgxLegendComponent } from './igx-legend-component';
import { TypeRegistrar } from './type';
import { LegendTemplates } from './LegendTemplates';
export class IgxLegendModule {
    constructor() {
        TypeRegistrar.register("LegendTemplates", LegendTemplates.$type);
    }
}
IgxLegendModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    CommonModule,
                ],
                declarations: [
                    IgxLegendComponent
                ],
                exports: [
                    IgxLegendComponent
                ]
            },] },
];
/** @nocollapse */
IgxLegendModule.ctorParameters = () => [];
//# sourceMappingURL=igx-legend-module.js.map