import { fromRect } from "./componentUtil";
/**
 * Provides data for rectangle changed events.
*/
export class RectChangedEventArgs {
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
         * Gets the rectangle before the change.
        */
    get oldRect() {
        return fromRect(this.i.oldRect);
    }
    /**
         * Gets the new rectangle.
        */
    get newRect() {
        return fromRect(this.i.newRect);
    }
}
//# sourceMappingURL=igx-rect-changed-event-args.js.map