/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { FinancialSeries } from "./FinancialSeries";
import { DependencyProperty } from "./DependencyProperty";
import { ISortingAxis_$type } from "./ISortingAxis";
import { Type, typeCast, markType } from "./type";
import { Rect } from "./Rect";
import { ScalerParams } from "./ScalerParams";
import { AxisRange } from "./AxisRange";
import { PropertyMetadata } from "./PropertyMetadata";
import { isNaN_ } from "./number";
var FinancialOverlay = /** @class */ (function (_super) {
    tslib_1.__extends(FinancialOverlay, _super);
    function FinancialOverlay() {
        var _this = _super.call(this) || this;
        _this.ov = false;
        _this.ov = false;
        return _this;
    }
    FinancialOverlay.prototype.hh = function (a, b, c, d) {
        _super.prototype.hh.call(this, a, b, c, d);
        if (this.ln != null && typeCast(ISortingAxis_$type, this.ln) !== null) {
            this.ln.i$i();
        }
        this.l3.bs.e(this.ej);
        this.ow();
        if (this.l7 != null) {
            this.l7.cb();
        }
        this.it(true);
    };
    FinancialOverlay.prototype.get_dr = function () {
        return true;
    };
    Object.defineProperty(FinancialOverlay.prototype, "dr", {
        get: function () {
            return this.get_dr();
        },
        enumerable: true,
        configurable: true
    });
    FinancialOverlay.prototype.ie = function (a, b, c, d) {
        switch (b) {
            case "FastItemsSource":
                this.ov = false;
                break;
            case FinancialOverlay.$$p[0]:
                this.ov = false;
                this.it(false);
                this.h1();
                break;
            case "XAxis":
                this.ov = false;
                break;
        }
        _super.prototype.ie.call(this, a, b, c, d);
    };
    FinancialOverlay.prototype.bc = function () {
        if (this.bd == 0) {
            return 1;
        }
        else {
            return _super.prototype.bc.call(this);
        }
    };
    FinancialOverlay.prototype.dd = function (a, b) {
        if (this.dc(a, b)) {
            return true;
        }
        return false;
    };
    FinancialOverlay.prototype.ac = function () {
        _super.prototype.ac.call(this);
        this.it(false);
    };
    FinancialOverlay.prototype.c5 = function (a) {
        var b = this.by != null ? this.by.indexOf(a) : -1;
        var c = this.bh.bq;
        c = c.copy();
        var d = this.bh.bp;
        var e = new Rect(0, 0, 0, 1, 1);
        var f = this.k7(this.bh);
        var g = new ScalerParams(0, e, e, this.ln.bz, f);
        var h = new ScalerParams(0, e, e, this.l7.bz, f);
        if (b >= 0 && Rect.l_op_Inequality(c, null) && Rect.l_op_Inequality(d, null)) {
            if (this.ln != null) {
                var i = this.ln.dj(b, g);
                if (i < c.left + 0.1 * c.width) {
                    i = i + 0.4 * c.width;
                }
                if (i > c.right - 0.1 * c.width) {
                    i = i - 0.4 * c.width;
                }
                c.x = i - 0.5 * c.width;
            }
            if (this.l7 != null && this.md != null && this.mb != null && b < this.md.count && b < this.mb.count) {
                var j = this.l7.dj(this.md.item(b), h);
                var k = this.l7.dj(this.mb.item(b), h);
                if (!isNaN_(j) && !isNaN_(k)) {
                    var l = Math.abs(j - k);
                    if (c.height < l) {
                        c.height = l;
                        c.y = Math.min(j, k);
                    }
                    else {
                        if (j < c.top + 0.1 * c.height) {
                            j = j + 0.4 * c.height;
                        }
                        if (j > c.bottom - 0.1 * c.height) {
                            j = j - 0.4 * c.height;
                        }
                        c.y = j - 0.5 * c.height;
                    }
                }
            }
            this.bm.ap(this.br, c, true);
        }
        return b >= 0;
    };
    FinancialOverlay.prototype.am = function (a) {
        if (a != null && a == this.l7 && this.md != null && this.mb != null) {
            return new AxisRange(this.md.minimum, this.mb.maximum);
        }
        return null;
    };
    FinancialOverlay.$t = markType(FinancialOverlay, 'FinancialOverlay', FinancialSeries.$);
    return FinancialOverlay;
}(FinancialSeries));
export { FinancialOverlay };
Type.dep(DependencyProperty, PropertyMetadata, FinancialOverlay, 'raisePropertyChanged', ['IgnoreFirst:ox:oz', [1, 0]]);
/*<BeginStatics Name="Infragistics.Controls.Charts.FinancialOverlay" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.FinancialOverlay" />*/
//# sourceMappingURL=FinancialOverlay.js.map