import { RangeCategorySeries } from "./RangeCategorySeries";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { NumericYAxis } from "./NumericYAxis";
import { Axis } from "./Axis";
import { Point, Type } from "./type";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { ScalerParams } from "./ScalerParams";
export declare abstract class HorizontalRangeCategorySeries extends RangeCategorySeries {
    xAxis: CategoryAxisBase;
    yAxis: NumericYAxis;
    fetchXAxis(): Axis;
    fetchYAxis(): Axis;
    hc(): void;
    ag(a: Point): Point[][];
    ah(a: Point): Point[][];
    protected get_c1(): boolean;
    readonly c1: boolean;
    protected bc(): SeriesHitTestMode;
    getOffsetValue(): number;
    getCategoryWidth(): number;
    e1(a: Point, b: boolean): number;
    e3(a: Point, b: boolean): number;
    d0(a: Point, b: number, c: Axis, d: ScalerParams, e: number): number;
    ed(a: Point, b: boolean, c: boolean): number;
    eb(a: Point, b: boolean, c: boolean): number;
    d9(a: Point, b: boolean, c: boolean): number;
    kw(a: Point, b: boolean, c: boolean): Point;
    ky(a: Point, b: boolean, c: boolean): Point;
    k0(a: Point, b: boolean, c: boolean): Point;
    ng(): boolean;
    protected ie(a: any, b: string, c: any, d: any): void;
    ou(a: any): boolean;
    ot(a: any): boolean;
    readonly useHighMarkerFidelity: boolean;
    static $$p: string[];
    static $t: Type;
}
