import { Rect } from "./Rect";
import { AxisRangeChangedEventArgs } from "./AxisRangeChangedEventArgs";
import { Type } from "./type";
export interface ITimeRangeSelectorAxis {
    readonly actualMinimumValue: Date;
    readonly actualMaximumValue: Date;
    readonly visibleMinimum: Date;
    readonly visibleMaximum: Date;
    getWindowRectForSelection(a: Date, b: Date): Rect;
    actualRangeChanged: (sender: any, e: AxisRangeChangedEventArgs) => void;
}
export declare let ITimeRangeSelectorAxis_$type: Type;
