import { Path } from "./Path";
import { IList$1, Type } from "./type";
import { Brush } from "./Brush";
export interface ITrackBarVisual {
    readonly barBox: Path;
    readonly allPaths: IList$1<Path>;
    width: number;
    height: number;
    translateX: number;
    translateY: number;
    getBarBoxDefaultBrush(): Brush;
    getBarBoxDefaultOutline(): Brush;
    getBarBoxDefaultStrokeThickness(): number;
}
export declare let ITrackBarVisual_$type: Type;
