/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { HorizontalAnchoredCategorySeries } from "./HorizontalAnchoredCategorySeries";
import { IUnknownValuePlotting_$type } from "./IUnknownValuePlotting";
import { CategoryLineRasterizer } from "./CategoryLineRasterizer";
import { UnknownValuePlotting_$type } from "./UnknownValuePlotting";
import { DependencyProperty } from "./DependencyProperty";
import { Type, typeCast, runOn, enumGetBox, markType } from "./type";
import { Path } from "./Path";
import { ScalerParams } from "./ScalerParams";
import { PropertyMetadata } from "./PropertyMetadata";
import { AnchoredCategorySeriesView } from "./AnchoredCategorySeriesView";
import { ISortingAxis_$type } from "./ISortingAxis";
import { Color } from "./Color";
var LineSeries = /** @class */ (function (_super) {
    tslib_1.__extends(LineSeries, _super);
    function LineSeries() {
        var _this = _super.call(this) || this;
        _this.pw = null;
        _this.pw = new CategoryLineRasterizer();
        _this.ab = LineSeries.$;
        _this.pg = 0;
        return _this;
    }
    LineSeries.prototype.be = function () {
        return new LineSeriesView(this);
    };
    LineSeries.prototype.h9 = function (a) {
        _super.prototype.h9.call(this, a);
        this.px = a;
    };
    LineSeries.prototype.get_ci = function () {
        return true;
    };
    Object.defineProperty(LineSeries.prototype, "ci", {
        get: function () {
            return this.get_ci();
        },
        enumerable: true,
        configurable: true
    });
    LineSeries.prototype.preferredCategoryMode = function (a) {
        return this.pg;
    };
    LineSeries.prototype.he = function (a, b) {
        _super.prototype.he.call(this, a, b);
        var c = b;
        c.c5();
    };
    LineSeries.prototype.n2 = function (a, b) {
        _super.prototype.n2.call(this, a, b);
        var c = b.cl.d;
        var d = typeCast(LineSeriesView.$, b);
        var e = a.f;
        var f = this.getEffectiveViewport1(b);
        this.mt.x(this, this.ne(), this.pd, runOn(this, this.mf), this.nm(b), this.nn(b));
        var g = false;
        var h = this.mt.c;
        if (h != null) {
            g = true;
        }
        if (g) {
            var i = new ScalerParams(0, b.bq, b.bp, this.pd.bz, f);
            this.ny(e, -1, this.valueColumn.count, this.pd, i, b.n);
        }
        var j = d.db;
        var k = d.dc;
        var l = d.da;
        this.mt.ae(j, true, false, true, false);
        this.mt.ae(k, true, false, true, false);
        this.mt.ae(l, false, true, false, false);
        l._opacity = 0.75 * this.mt.i;
        if (b.cp(a)) {
            d.c6(e.count, e, true, this.unknownValuePlotting, this.oc(e, e.count - 1, b.bp, b.bq), c, this.ej);
            b.cs(a);
        }
    };
    LineSeries.prototype.ie = function (a, b, c, d) {
        _super.prototype.ie.call(this, a, b, c, d);
        switch (b) {
            case LineSeries.$$p[0]:
                this.mq.m = this.unknownValuePlotting == 0;
                this.it(false);
                this.h1();
                break;
        }
    };
    Object.defineProperty(LineSeries.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.nh;
        },
        enumerable: true,
        configurable: true
    });
    LineSeries.$t = markType(LineSeries, 'LineSeries', HorizontalAnchoredCategorySeries.$, [IUnknownValuePlotting_$type]);
    return LineSeries;
}(HorizontalAnchoredCategorySeries));
export { LineSeries };
Type.dep(DependencyProperty, PropertyMetadata, LineSeries, 'raisePropertyChanged', ['UnknownValuePlotting::pz', [UnknownValuePlotting_$type, enumGetBox(UnknownValuePlotting_$type, 1)]]);
var LineSeriesView = /** @class */ (function (_super) {
    tslib_1.__extends(LineSeriesView, _super);
    function LineSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.c4 = null;
        _this.de = new Path();
        _this.dd = new Path();
        _this.df = new Path();
        _this.c9 = new Path();
        _this.c8 = new Path();
        _this.c7 = new Path();
        _this.c4 = a;
        return _this;
    }
    Object.defineProperty(LineSeriesView.prototype, "db", {
        get: function () {
            return this.de;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LineSeriesView.prototype, "dc", {
        get: function () {
            return this.df;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LineSeriesView.prototype, "da", {
        get: function () {
            return this.dd;
        },
        enumerable: true,
        configurable: true
    });
    LineSeriesView.prototype.c5 = function () {
        this.dd.aj = null;
        this.de.aj = null;
        this.df.aj = null;
        this.an();
    };
    LineSeriesView.prototype.c6 = function (a, b, c, d, e, f, g) {
        this.c4.pw.a = typeCast(ISortingAxis_$type, this.cn.fetchXAxis()) !== null ? true : false;
        this.c4.pw.m(this.de, this.dd, this.df, a, b, c, d, e, f, g);
        this.an();
    };
    LineSeriesView.prototype.a8 = function () {
        _super.prototype.a8.call(this);
    };
    LineSeriesView.prototype.a9 = function () {
        _super.prototype.a9.call(this);
        this.c8.aj = this.de.aj;
        this.c9.aj = this.df.aj;
        this.c7.aj = this.dd.aj;
        var a = this.bk();
        this.c8._stroke = a;
        this.c8.ac = this.e.en + 3;
        this.c9._stroke = a;
        this.c9.ac = this.e.en + 3;
        this.c7._fill = a;
        this.c7._opacity = 1;
    };
    LineSeriesView.prototype.a3 = function (a, b) {
        _super.prototype.a3.call(this, a, b);
        if (a.d) {
            if (b) {
                a.s(this.c7);
                a.s(this.c8);
                a.s(this.c9);
            }
            else {
                a.s(this.dd);
                a.s(this.de);
                a.s(this.df);
            }
        }
    };
    LineSeriesView.prototype.ai = function (a) {
        _super.prototype.ai.call(this, a);
        this.e.a1.exportPathData(a, this.de, "lowerShape", ["Lower", "Main"]);
        this.e.a1.exportPathData(a, this.df, "upperShape", ["Upper"]);
        this.e.a1.exportPathData(a, this.dd, "translucentShape", ["Translucent"]);
    };
    LineSeriesView.prototype.ac = function () {
        var a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.kp = a;
        this.e.ek = 3;
        this.e.el = 1;
        this.e.em = 4;
        this.e.dq = false;
    };
    LineSeriesView.$t = markType(LineSeriesView, 'LineSeriesView', AnchoredCategorySeriesView.$);
    return LineSeriesView;
}(AnchoredCategorySeriesView));
export { LineSeriesView };
/*<BeginStatics Name="Infragistics.Controls.Charts.LineSeries" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.LineSeries" />*/
//# sourceMappingURL=LineSeries_combined.js.map