import { CategoryXAxis } from "./CategoryXAxis";
import { ITimeRangeSelectorAxis } from "./ITimeRangeSelectorAxis";
import { TimeAxisLabelFormatCollection } from "./TimeAxisLabelFormatCollection";
import { FastItemsSourceEventArgs } from "./FastItemsSourceEventArgs";
import { IList$1, Type } from "./type";
import { AxisRangeChangedEventArgs } from "./AxisRangeChangedEventArgs";
import { ScalerParams } from "./ScalerParams";
import { Rect } from "./Rect";
import { IGetItemAtIndex } from "./IGetItemAtIndex";
export declare class OrdinalTimeXAxis extends CategoryXAxis implements ITimeRangeSelectorAxis {
    constructor();
    protected f7(a: any, b: string, c: any, d: any): void;
    private k1;
    actualMinimumValue: Date;
    private k0;
    actualMaximumValue: Date;
    private k3;
    visibleMinimum: Date;
    private k2;
    visibleMaximum: Date;
    protected jw(a: FastItemsSourceEventArgs): void;
    private lf();
    private lg();
    private k8;
    la: string;
    private ky;
    private kz;
    protected gv(a: Rect, b: Rect): void;
    getWindowRectForSelection(a: Date, b: Date): Rect;
    private kw;
    actualRangeChanged: (sender: any, e: AxisRangeChangedEventArgs) => void;
    readonly kx: TimeAxisLabelFormatCollection;
    private le(a, b);
    f9(a: string): void;
    eq(a: any): any;
    private readonly ld;
    protected ka(): IGetItemAtIndex;
    protected gu(a: Rect, b: Rect): void;
    protected kg(a: number, b: ScalerParams): number;
    protected kf(a: number, b: number, c: boolean, d: ScalerParams): number;
    readonly isVertical: boolean;
    j$c(a: number, b: ScalerParams): number;
    j$b(a: number, b: ScalerParams): number;
    j$d(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    j$e(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    j$f(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    readonly j$a: boolean;
    static $t: Type;
}
