import { HorizontalRangeCategorySeries } from "./HorizontalRangeCategorySeries";
import { SeriesView } from "./SeriesView";
import { Type, Point } from "./type";
import { CategoryMode } from "./CategoryMode";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { Rect } from "./Rect";
import { CategoryFrame } from "./CategoryFrame";
import { List$1 } from "./List$1";
import { Pool$1 } from "./Pool$1";
import { CategorySeriesView } from "./CategorySeriesView";
import { Rectangle } from "./Rectangle";
import { RangeCategorySeriesView } from "./RangeCategorySeriesView";
import { RenderingContext } from "./RenderingContext";
export declare class RangeColumnSeries extends HorizontalRangeCategorySeries {
    protected be(): SeriesView;
    h9(a: SeriesView): void;
    oz: RangeColumnSeriesView;
    constructor();
    o0: number;
    o1: number;
    protected get_na(): boolean;
    protected readonly na: boolean;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    k9(a: Point): Rect;
    dd(a: Point, b: boolean): boolean;
    he(a: boolean, b: SeriesView): void;
    d7(): number;
    n2(a: CategoryFrame, b: CategorySeriesView): void;
    readonly useHighMarkerFidelity: boolean;
    static $$p: string[];
    static $t: Type;
}
export declare class RangeColumnSeriesView extends RangeCategorySeriesView {
    protected cw: RangeColumnSeries;
    constructor(a: RangeColumnSeries);
    cx: Pool$1<Rectangle>;
    ap(): void;
    protected cy: List$1<Rectangle>;
    c4(): Rectangle;
    cz(a: Rectangle): void;
    c1(a: Rectangle): void;
    c0(a: Rectangle): void;
    c2(a: Rectangle, b: number, c: number): void;
    protected z(a: number): any;
    private c3;
    protected y(a: number): any;
    protected a3(a: RenderingContext, b: boolean): void;
    ai(a: any): void;
    static $t: Type;
}
