import { FinancialIndicator } from "./FinancialIndicator";
import { IndicatorCalculationStrategy } from "./IndicatorCalculationStrategy";
import { Type, IList$1 } from "./type";
import { DependencyProperty } from "./DependencyProperty";
import { List$1 } from "./List$1";
import { FinancialCalculationDataSource } from "./FinancialCalculationDataSource";
export declare abstract class StrategyBasedIndicator extends FinancialIndicator {
    constructor();
    protected p3(): void;
    protected po: IndicatorCalculationStrategy;
    protected readonly abstract pp: IndicatorCalculationStrategy;
    protected readonly abstract p2: Type;
    static ps: List$1<string>;
    protected pv(): number;
    p4(a: number): void;
    protected px(): number;
    protected pu(): number;
    static p8(a: number, b: Type, c: string): DependencyProperty;
    protected static p7(a: number, b: Type): DependencyProperty;
    protected static p5(a: number, b: Type): DependencyProperty;
    protected static p9(a: number, b: Type): DependencyProperty;
    protected o1(a: number, b: number): IList$1<string>;
    protected oy(a: number, b: number): boolean;
    protected pr(a: FinancialCalculationDataSource): boolean;
    private pq(a, b);
    protected pw(a: number): number;
    protected lz(a: number, b: number): FinancialCalculationDataSource;
    protected pt(): number;
    protected static p6(a: number, b: Type): DependencyProperty;
    protected ie(a: any, b: string, c: any, d: any): void;
    static $t: Type;
}
