import { SeriesViewer } from "./SeriesViewer";
import { Rect } from "./Rect";
import { Dictionary$2 } from "./Dictionary$2";
import { ITileZoomTile } from "./ITileZoomTile";
import { List$1 } from "./List$1";
import { TileZoomTileInfo } from "./TileZoomTileInfo";
import { Base, Type } from "./type";
import { ITileZoomTileInfo } from "./ITileZoomTileInfo";
import { LinkedListNode$1 } from "./LinkedListNode$1";
export declare class TileZoomManager extends Base {
    protected e: SeriesViewer;
    protected av: Rect;
    aw: Rect;
    au: Rect;
    protected i: boolean;
    protected v: number;
    protected k: Dictionary$2<TileZoomTile, ITileZoomTile>;
    protected l: Dictionary$2<TileZoomTile, ITileZoomTile>;
    protected n: List$1<ITileZoomTile>;
    constructor(a: SeriesViewer, b: boolean, c: number);
    private q;
    private ai();
    protected ao: Rect;
    private ap(a);
    private t(a);
    private s();
    private an(a, b);
    private am(a, b);
    private aj();
    private p;
    private r;
    private j(a);
    private g(a);
    private ag();
    private aa(a, b);
    private ak();
    private ad(a);
    private z(a);
    private b(a, b);
    private ar();
    private as(a, b);
    private y;
    private c(a);
    protected o: List$1<TileZoomTileInfo>;
    protected m: List$1<TileZoomTile>;
    private a();
    private aq(a);
    private at(a, b, c, d, e, f, g);
    private af();
    private x(a);
    protected d: TileZoomTileCache;
    private f;
    ab(): void;
    al(): void;
    ah(): void;
    h: boolean;
    ae(a: TileZoomTile): void;
    ac(): void;
    static $t: Type;
}
export declare class TileZoomTileCache extends Base {
    private c;
    private d;
    private e;
    private a;
    constructor(a: number, b: TileZoomManager);
    g(): void;
    i(a: TileZoomTile): void;
    f(a: TileZoomTile): void;
    private h(a);
    b(a: TileZoomTileInfo): TileZoomTile;
    static $t: Type;
}
export declare class TileZoomTile extends Base implements ITileZoomTile {
    private _info;
    info: ITileZoomTileInfo;
    a: TileZoomTileCache;
    b: LinkedListNode$1<TileZoomTile>;
    touch(): void;
    private _content;
    content: any;
    private _xPosition;
    xPosition: number;
    private _width;
    width: number;
    private _yPosition;
    yPosition: number;
    private _height;
    height: number;
    private _iD;
    iD: number;
    static $t: Type;
}
