/**
 * Represents a calculation strategy that uses the calculation data source
 * to product a column of values.
*/
var /**
 * Represents a calculation strategy that uses the calculation data source
 * to product a column of values.
*/
DataSourceSupportingCalculation = /** @class */ (function () {
    function DataSourceSupportingCalculation() {
    }
    Object.defineProperty(DataSourceSupportingCalculation.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    DataSourceSupportingCalculation.prototype.onImplementationCreated = function () {
    };
    DataSourceSupportingCalculation.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    return DataSourceSupportingCalculation;
}());
/**
 * Represents a calculation strategy that uses the calculation data source
 * to product a column of values.
*/
export { DataSourceSupportingCalculation };
//# sourceMappingURL=igx-data-source-supporting-calculation.js.map