import { IgxRect } from './IgxRect';
import { RectChangedEventArgs as RectChangedEventArgs_internal } from "./RectChangedEventArgs";
/**
 * Provides data for rectangle changed events.
*/
export declare class RectChangedEventArgs {
    protected _implementation: any;
    readonly i: RectChangedEventArgs_internal;
    private onImplementationCreated();
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Gets the rectangle before the change.
    */
    readonly oldRect: IgxRect;
    /**
     * Gets the new rectangle.
    */
    readonly newRect: IgxRect;
}
