import { fromRect } from "./componentUtil";
/**
 * Provides data for rectangle changed events.
*/
var /**
 * Provides data for rectangle changed events.
*/
RectChangedEventArgs = /** @class */ (function () {
    function RectChangedEventArgs() {
    }
    Object.defineProperty(RectChangedEventArgs.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    RectChangedEventArgs.prototype.onImplementationCreated = function () {
    };
    RectChangedEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(RectChangedEventArgs.prototype, "oldRect", {
        /**
         * Gets the rectangle before the change.
        */
        get: /**
             * Gets the rectangle before the change.
            */
        function () {
            return fromRect(this.i.oldRect);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RectChangedEventArgs.prototype, "newRect", {
        /**
         * Gets the new rectangle.
        */
        get: /**
             * Gets the new rectangle.
            */
        function () {
            return fromRect(this.i.newRect);
        },
        enumerable: true,
        configurable: true
    });
    return RectChangedEventArgs;
}());
/**
 * Provides data for rectangle changed events.
*/
export { RectChangedEventArgs };
//# sourceMappingURL=igx-rect-changed-event-args.js.map