import * as tslib_1 from "tslib";
import { Component, forwardRef, ChangeDetectionStrategy } from '@angular/core';
import { IgxHorizontalAnchoredCategorySeriesComponent } from './igx-horizontal-anchored-category-series-component';
import { IgxAnchoredCategorySeriesComponent } from './igx-anchored-category-series-component';
import { IgxCategorySeriesComponent } from './igx-category-series-component';
import { IgxMarkerSeriesComponent } from './igx-marker-series-component';
import { IgxSeriesComponent } from './igx-series-component';
import { StepAreaSeries } from "./StepAreaSeries";
/**
 * Represents a IgxDataChartComponent step area series.
*/
export var IgxStepAreaSeriesComponent_PROVIDERS = [{ provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: forwardRef(function () { return IgxStepAreaSeriesComponent; }) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(function () { return IgxStepAreaSeriesComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(function () { return IgxStepAreaSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(function () { return IgxStepAreaSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxStepAreaSeriesComponent; }) }];
var IgxStepAreaSeriesComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxStepAreaSeriesComponent, _super);
    function IgxStepAreaSeriesComponent() {
        return _super.call(this) || this;
    }
    IgxStepAreaSeriesComponent.prototype.createImplementation = function () {
        return new StepAreaSeries();
    };
    Object.defineProperty(IgxStepAreaSeriesComponent.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxStepAreaSeriesComponent.prototype, "isAreaOrLine", {
        /**
         * Gets whether the current series shows an area or line shape.
        */
        get: /**
             * Gets whether the current series shows an area or line shape.
            */
        function () {
            return this.i.ci;
        },
        enumerable: true,
        configurable: true
    });
    IgxStepAreaSeriesComponent.decorators = [
        { type: Component, args: [{
                    selector: 'igx-step-area-series',
                    template: "",
                    providers: [{ provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: forwardRef(function () { return IgxStepAreaSeriesComponent; }) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(function () { return IgxStepAreaSeriesComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(function () { return IgxStepAreaSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(function () { return IgxStepAreaSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxStepAreaSeriesComponent; }) }],
                    changeDetection: ChangeDetectionStrategy.OnPush
                },] },
    ];
    /** @nocollapse */
    IgxStepAreaSeriesComponent.ctorParameters = function () { return []; };
    return IgxStepAreaSeriesComponent;
}(IgxHorizontalAnchoredCategorySeriesComponent));
export { IgxStepAreaSeriesComponent };
//# sourceMappingURL=igx-step-area-series-component.js.map