/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { IShortPeriodLongPeriod_$type } from "./IShortPeriodLongPeriod";
import { AbsoluteVolumeOscillatorIndicatorStrategy } from "./AbsoluteVolumeOscillatorIndicatorStrategy";
import { typeGetValue, markType } from "./type";
export class AbsoluteVolumeOscillatorIndicator extends StrategyBasedIndicator {
    get_pp() {
        return new AbsoluteVolumeOscillatorIndicatorStrategy();
    }
    get pp() {
        return this.get_pp();
    }
    get_p2() {
        return AbsoluteVolumeOscillatorIndicator.$;
    }
    get p2() {
        return this.get_p2();
    }
    get shortPeriod() {
        return typeGetValue(this.c(AbsoluteVolumeOscillatorIndicator.qb));
    }
    set shortPeriod(a) {
        this.h(AbsoluteVolumeOscillatorIndicator.qb, a);
    }
    px() {
        return this.shortPeriod;
    }
    get longPeriod() {
        return typeGetValue(this.c(AbsoluteVolumeOscillatorIndicator.qa));
    }
    set longPeriod(a) {
        this.h(AbsoluteVolumeOscillatorIndicator.qa, a);
    }
    pu() {
        return this.longPeriod;
    }
}
AbsoluteVolumeOscillatorIndicator.qb = StrategyBasedIndicator.p9(10, AbsoluteVolumeOscillatorIndicator.$);
AbsoluteVolumeOscillatorIndicator.qa = StrategyBasedIndicator.p5(30, AbsoluteVolumeOscillatorIndicator.$);
AbsoluteVolumeOscillatorIndicator.$t = markType(AbsoluteVolumeOscillatorIndicator, 'AbsoluteVolumeOscillatorIndicator', StrategyBasedIndicator.$, [IShortPeriodLongPeriod_$type]);
/*<BeginStatics Name="Infragistics.Controls.Charts.AbsoluteVolumeOscillatorIndicator" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.AbsoluteVolumeOscillatorIndicator" />*/
//# sourceMappingURL=AbsoluteVolumeOscillatorIndicator.js.map