import { HorizontalAnchoredCategorySeries } from "./HorizontalAnchoredCategorySeries";
import { IUnknownValuePlotting } from "./IUnknownValuePlotting";
import { CategoryLineRasterizer } from "./CategoryLineRasterizer";
import { UnknownValuePlotting } from "./UnknownValuePlotting";
import { SeriesView } from "./SeriesView";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { Type, Point } from "./type";
import { CategoryMode } from "./CategoryMode";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { CategoryFrame } from "./CategoryFrame";
import { CategorySeriesView } from "./CategorySeriesView";
import { List$1 } from "./List$1";
import { Path } from "./Path";
import { PointCollection } from "./PointCollection";
import { AnchoredCategorySeriesView } from "./AnchoredCategorySeriesView";
import { Clipper } from "./Clipper";
import { RenderingContext } from "./RenderingContext";
export declare class AreaSeries extends HorizontalAnchoredCategorySeries implements IUnknownValuePlotting {
    protected be(): SeriesView;
    protected mv(): CategoryTransitionInMode;
    h9(a: SeriesView): void;
    pw: AreaSeriesView;
    protected get_ci(): boolean;
    readonly ci: boolean;
    constructor();
    px: CategoryLineRasterizer;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    dd(a: Point, b: boolean): boolean;
    he(a: boolean, b: SeriesView): void;
    n2(a: CategoryFrame, b: CategorySeriesView): void;
    unknownValuePlotting: UnknownValuePlotting;
    protected ie(a: any, b: string, c: any, d: any): void;
    readonly useHighMarkerFidelity: boolean;
    static $$p: string[];
    static $t: Type;
}
export declare class AreaSeriesView extends AnchoredCategorySeriesView {
    protected c4: AreaSeries;
    constructor(a: AreaSeries);
    ap(): void;
    readonly dc: Path;
    readonly dd: Path;
    readonly df: Path;
    readonly dh: Path;
    private de;
    private di;
    private dg;
    private dj;
    c5(): void;
    c6(a: number, b: List$1<number[]>, c: boolean, d: number, e: number, f: (arg1: PointCollection, arg2: PointCollection, arg3: PointCollection, arg4: PointCollection, arg5: boolean) => void, g: UnknownValuePlotting): void;
    c7(a: number, b: List$1<number[]>, c: boolean, d: number, e: number, f: (arg1: PointCollection, arg2: PointCollection, arg3: PointCollection, arg4: PointCollection, arg5: boolean) => void, g: UnknownValuePlotting, h: Clipper): void;
    private c8;
    private da;
    private c9;
    private db;
    protected a9(): void;
    protected a3(a: RenderingContext, b: boolean): void;
    ai(a: any): void;
    protected ac(): void;
    static $t: Type;
}
