import { IRenderer } from "./IRenderer";
import { LinearGradientBrush } from "./LinearGradientBrush";
import { Rectangle } from "./Rectangle";
import { Shape } from "./Shape";
import { Path } from "./Path";
import { Geometry } from "./Geometry";
import { Base, Type } from "./type";
import { Rect } from "./Rect";
import { TextBlock } from "./TextBlock";
import { Polygon } from "./Polygon";
import { Polyline } from "./Polyline";
import { DataTemplateRenderInfo } from "./DataTemplateRenderInfo";
import { ContentControl } from "./ContentControl";
import { Transform } from "./Transform";
import { Line } from "./Line";
import { FontInfo } from "./FontInfo";
import { Style } from "./Style";
export declare class CanvasViewRenderer extends Base implements IRenderer {
    private i;
    h$e(): any;
    h$d: any;
    k(a: LinearGradientBrush, b: number, c: number, d: number, e: number, f: number, g: boolean): CanvasGradient;
    static j(a: CanvasRenderingContext2D, b: LinearGradientBrush, c: number, d: number, e: number, f: number, g: number, h: boolean): CanvasGradient;
    h$t(a: Rectangle): void;
    private g;
    private e;
    private h;
    private f;
    private b;
    private c;
    h$q(a: Path): void;
    h$o(a: Geometry): void;
    private o(a);
    private s(a);
    private p(a);
    private w(a);
    private z;
    private y(a, b, c, d, e, f, g, h);
    private n(a);
    private t(a);
    private x(a, b, c, d, e);
    private m(a);
    private r(a);
    private u(a);
    private v(a);
    private q(a);
    private l;
    h$u(a: TextBlock): void;
    h$v(a: TextBlock, b: Rect, c: number): void;
    h$r(a: Polygon): void;
    h$s(a: Polyline): void;
    h$n(a: DataTemplateRenderInfo, b: ContentControl): void;
    h$h(a: Transform): void;
    h$p(a: Line): void;
    h$ac(a: Rect): void;
    h$x(): void;
    h$w(): void;
    h$y(a: number, b: number): void;
    h$ad(a: number, b: number): void;
    h$i(a: number, b: number, c: number, d: number): void;
    h$k(a: any, b: number, c: number, d: number, e: number, f: number): void;
    h$l(a: any, b: number, c: number, d: number, e: number, f: number, g: number, h: number, i: number, j: number): void;
    h$a(a: number, b: number): number[];
    h$f(): string;
    h$b(): FontInfo;
    h$z(a: string): void;
    private a;
    h$aa(a: FontInfo): void;
    h$c(a: string): number;
    private d;
    h$ab(a: number): void;
    h$g(shape_: Shape, style_: Style): void;
    h$m(a: string, b: number, c: number, d: number): void;
    h$j(): void;
    static $t: Type;
}
