/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { IShortPeriodLongPeriod_$type } from "./IShortPeriodLongPeriod";
import { ChaikinOscillatorIndicatorStrategy } from "./ChaikinOscillatorIndicatorStrategy";
import { typeGetValue, markType } from "./type";
export class ChaikinOscillatorIndicator extends StrategyBasedIndicator {
    get_pp() {
        return new ChaikinOscillatorIndicatorStrategy();
    }
    get pp() {
        return this.get_pp();
    }
    get_p2() {
        return ChaikinOscillatorIndicator.$;
    }
    get p2() {
        return this.get_p2();
    }
    get shortPeriod() {
        return typeGetValue(this.c(ChaikinOscillatorIndicator.qb));
    }
    set shortPeriod(a) {
        this.h(ChaikinOscillatorIndicator.qb, a);
    }
    px() {
        return this.shortPeriod;
    }
    get longPeriod() {
        return typeGetValue(this.c(ChaikinOscillatorIndicator.qa));
    }
    set longPeriod(a) {
        this.h(ChaikinOscillatorIndicator.qa, a);
    }
    pu() {
        return this.longPeriod;
    }
}
ChaikinOscillatorIndicator.qb = StrategyBasedIndicator.p9(3, ChaikinOscillatorIndicator.$);
ChaikinOscillatorIndicator.qa = StrategyBasedIndicator.p5(10, ChaikinOscillatorIndicator.$);
ChaikinOscillatorIndicator.$t = markType(ChaikinOscillatorIndicator, 'ChaikinOscillatorIndicator', StrategyBasedIndicator.$, [IShortPeriodLongPeriod_$type]);
/*<BeginStatics Name="Infragistics.Controls.Charts.ChaikinOscillatorIndicator" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.ChaikinOscillatorIndicator" />*/
//# sourceMappingURL=ChaikinOscillatorIndicator.js.map