/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { HorizontalAnchoredCategorySeries } from "./HorizontalAnchoredCategorySeries";
import { DependencyProperty } from "./DependencyProperty";
import { ConsolidatedItemsPosition_$type } from "./ConsolidatedItemsPosition";
import { Type, runOn, enumGetBox, markType, fromEnum } from "./type";
import { Pool$1 } from "./Pool$1";
import { List$1 } from "./List$1";
import { ScalerParams } from "./ScalerParams";
import { Rectangle } from "./Rectangle";
import { PropertyMetadata } from "./PropertyMetadata";
import { isNaN_, isInfinity } from "./number";
import { AnchoredCategorySeriesView } from "./AnchoredCategorySeriesView";
export class ColumnSeries extends HorizontalAnchoredCategorySeries {
    constructor() {
        super();
        this.p2 = null;
        this.px = 0;
        this.ab = ColumnSeries.$;
        this.pg = 2;
    }
    be() {
        return new ColumnSeriesView(this);
    }
    h9(a) {
        super.h9(a);
        this.pw = a;
    }
    mv() {
        return 1;
    }
    get_na() {
        return true;
    }
    get na() {
        return this.get_na();
    }
    preferredCategoryMode(a) {
        return this.pg;
    }
    k9(a) {
        if (this.p2 == null) {
            this.p2 = runOn(this, this.pz);
        }
        let b = this.pj != null ? this.pj : this.yAxis;
        let c = this.pd;
        return this.oj.c$d(this, a, c, b, this.mm, this.nm(this.bh), this.nn(this.bh), this.p2);
    }
    dd(a, b) {
        if (this.dg(a, b)) {
            return true;
        }
        if (this.lj(a, b)) {
            return true;
        }
        return false;
    }
    he(a, b) {
        super.he(a, b);
        let c = b;
        if (a && c.c5 != null) {
            c.c5.count = 0;
        }
    }
    d7() {
        return this.pd.i3(this.bh.bq, this.bh.bp, this.getEffectiveViewport1(this.bh));
    }
    n2(a, b) {
        super.n2(a, b);
        let c = a.f;
        if (!b.q()) {
            return;
        }
        let d = b.bq;
        let e = b.bp;
        let f = this.getEffectiveViewport1(b);
        let g = new ScalerParams(0, d, e, this.pj.bz, f);
        let h = new ScalerParams(0, d, e, this.pd.bz, f);
        let i = this.pj;
        let j = i.dj(i.jq, g);
        let k = this.pd.i3(d, e, f);
        let l = this.pd;
        let m = b;
        if (isNaN_(k) || isInfinity(k)) {
            m.c5.count = 0;
            return;
        }
        this.mt.x(this, this.ne(), this.pd, runOn(this, this.mf), this.nm(b), this.nn(b));
        this.mt.p = this.p0;
        this.mt.q = this.p1;
        this.mt.j = this.p0;
        this.mt.k = this.p1;
        let n = false;
        let o = this.mt.c;
        if (o != null) {
            n = true;
        }
        let p = this.pd.b3;
        let q = p ? this.pd : null;
        let r = this.valueColumn.count;
        let s = this.nm(b);
        let t = 0;
        for (let u = 0; u < c.count; ++u) {
            let v = c._inner[u][0] - 0.5 * k;
            let w = this.pz(c._inner[u]);
            let x = j;
            w = Math.max(w, -100);
            x = Math.min(x, e.bottom + 100);
            let y = Math.abs(x - w);
            if (isInfinity(y)) {
                continue;
            }
            let z = m.c5.item(t);
            t++;
            z.width = k;
            z.height = y;
            if (n) {
                this.ny(c, u, r, l, h, b.n);
            }
            if (z.dataContext != null) {
                let aa = z.dataContext;
                if (s == 1) {
                    let ab = this.mt.a(r, u)[0];
                    if (ab >= 0 && ab < this.by.count) {
                        if (q != null && q.i$b != null && q.i$b.count > ab) {
                            ab = q.i$b._inner[ab];
                        }
                        aa.item = this.by.item(ab);
                    }
                }
                else {
                    aa.item = null;
                }
            }
            this.mt.ae(z, false, false, false, false);
            z.al = this.mt.j;
            z.am = this.mt.k;
            m.da(z, v, Math.min(x, w));
        }
        m.c5.count = t;
        b.cs(a);
    }
    get py() {
        return this.px;
    }
    set py(a) {
        if (this.py != a) {
            let b = this.py;
            this.px = a;
            this.raisePropertyChanged("ConsolidatedColumnVerticalPosition", enumGetBox(ConsolidatedItemsPosition_$type, b), enumGetBox(ConsolidatedItemsPosition_$type, this.py));
        }
    }
    pz(a) {
        if (a == null || a.length < 3) {
            return NaN;
        }
        switch (this.py) {
            case 0: return a[1];
            case 1: return a[2];
            case 2: return (a[1] + a[2]) / 2;
            case 3:
                let b = (a[1] + a[2]) / 2;
                if (this.yAxis == null) {
                    return b;
                }
                let c = this.yAxis.dm(b, new ScalerParams(1, this.br.my, this.br.mx, this.yAxis.bz));
                if (c < this.yAxis.jq) {
                    return a[2];
                }
                else {
                    return a[1];
                }
            case 4:
                let d = (a[1] + a[2]) / 2;
                let e = this.yAxis.dm(d, new ScalerParams(1, this.br.my, this.br.mx, this.yAxis.bz));
                if (this.yAxis == null) {
                    return d;
                }
                if (e < this.yAxis.jq) {
                    return a[1];
                }
                else {
                    return a[2];
                }
            default: return (a[1] + a[2]) / 2;
        }
    }
    get useHighMarkerFidelity() {
        return this.nh;
    }
}
ColumnSeries.$t = markType(ColumnSeries, 'ColumnSeries', HorizontalAnchoredCategorySeries.$);
Type.dep(DependencyProperty, PropertyMetadata, ColumnSeries, 'raisePropertyChanged', ['RadiusX:p0:p6', [1, 2], 'RadiusY:p1:p7', [1, 2]]);
export class ColumnSeriesView extends AnchoredCategorySeriesView {
    constructor(a) {
        super(a);
        this.c4 = null;
        this.c6 = null;
        this.db = new Rectangle();
        this.c5 = null;
        this.c4 = a;
        this.c5 = ((() => {
            let $ret = new Pool$1(Rectangle.$);
            $ret.create = runOn(this, this.dc);
            $ret.activate = runOn(this, this.c7);
            $ret.disactivate = runOn(this, this.c9);
            $ret.destroy = runOn(this, this.c8);
            return $ret;
        })());
    }
    ap() {
        super.ap();
        this.c6 = new List$1(Rectangle.$, 0);
        if (!this.n) {
            this.e.ej = 4;
            this.e.bi = 1;
        }
    }
    dc() {
        let a = new Rectangle();
        this.c6.add(a);
        a._visibility = 1;
        return a;
    }
    c7(a) {
        a._visibility = 0;
    }
    c9(a) {
        a._visibility = 1;
    }
    c8(a) {
        this.c6.remove(a);
    }
    da(a, b, c) {
        if (!this.isDirty) {
            this.an();
        }
        a.o = c;
        a.n = b;
    }
    z(a) {
        return this.c6._inner[a];
    }
    y(a) {
        let b = this.c6._inner[a];
        this.db._visibility = b._visibility;
        this.db.n = b.n;
        this.db.o = b.o;
        this.db.width = b.width;
        this.db.height = b.height;
        let c = this.bl(a);
        this.db._fill = c;
        this.db._stroke = c;
        this.db.ac = this.e.en + 3;
        return this.db;
    }
    a3(a, b) {
        super.a3(a, b);
        if (a.d) {
            for (let c = 0; c < this.c6.count; c++) {
                let d = this.x(c, b);
                this.ba(d, c, b);
                a.v(d);
            }
        }
    }
    ai(a) {
        super.ai(a);
        let b = 0;
        let c = new List$1(Rectangle.$, 0);
        for (let d of fromEnum(this.c5.a)) {
            c.add(d);
        }
        c.aa((e, f) => {
            if (e.n < f.n) {
                return -1;
            }
            else if (e.n > f.n) {
                return 1;
            }
            else {
                return 0;
            }
        });
        for (let e of fromEnum(c)) {
            this.e.a1.exportRectangleData(a, e, "column" + b, ["Main", "Fill"]);
        }
        b++;
    }
}
ColumnSeriesView.$t = markType(ColumnSeriesView, 'ColumnSeriesView', AnchoredCategorySeriesView.$);
/*<BeginStatics Name="Infragistics.Controls.Charts.ColumnSeries" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.ColumnSeries" />*/
//# sourceMappingURL=ColumnSeries_combined.js.map