import { IFastItemColumn$1 } from "./IFastItemColumn$1";
import { Type } from "./type";
export interface IBucketizer {
    getBucket(a: number): number[];
    getBucketWithoutUnknowns(a: number): number[];
    getErrorBucket(a: number, b: IFastItemColumn$1<number>): number;
    getBucketInfo(a: number, b: number, c: number, d: number): {
        p0: number;
        p1: number;
        p2: number;
        p3: number;
    };
    cacheValues(): void;
    unCacheValues(): void;
}
export declare let IBucketizer_$type: Type;
