import { Path } from "./Path";
import { TextBlock } from "./TextBlock";
import { IList$1, Type } from "./type";
import { Brush } from "./Brush";
export interface ITrackThumbCalloutVisual {
    readonly calloutBox: Path;
    readonly calloutText: TextBlock;
    readonly allPaths: IList$1<Path>;
    width: number;
    height: number;
    translateX: number;
    translateY: number;
    textTranslateX: number;
    textTranslateY: number;
    isVisible: boolean;
    getCalloutBoxDefaultStroke(): Brush;
    getCalloutBoxDefaultStrokeThickness(): number;
    getCalloutBoxDefaultBrush(): Brush;
    getCalloutTextDefaultBrush(): Brush;
}
export declare let ITrackThumbCalloutVisual_$type: Type;
