import { EventArgs, Point, Type } from "./type";
import { MouseEventArgs } from "./MouseEventArgs";
import { ILegendSeries } from "./ILegendSeries";
import { ILegendOwner } from "./ILegendOwner";
import { UIElement } from "./UIElement";
export declare class LegendMouseEventArgs extends EventArgs {
    constructor(a: ILegendOwner, b: ILegendSeries, c: any, d: MouseEventArgs, e: any);
    toString(): string;
    private _originalEvent;
    private originalEvent;
    getPosition(a: UIElement): Point;
    readonly originalSource: any;
    private _item;
    item: any;
    private _series;
    series: ILegendSeries;
    private _chart;
    chart: ILegendOwner;
    private _legendItem;
    legendItem: any;
    static $t: Type;
}
