/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { HorizontalAnchoredCategorySeries } from "./HorizontalAnchoredCategorySeries";
import { IUnknownValuePlotting_$type } from "./IUnknownValuePlotting";
import { CategoryLineRasterizer } from "./CategoryLineRasterizer";
import { UnknownValuePlotting_$type } from "./UnknownValuePlotting";
import { DependencyProperty } from "./DependencyProperty";
import { Type, typeCast, runOn, enumGetBox, markType } from "./type";
import { Path } from "./Path";
import { ScalerParams } from "./ScalerParams";
import { PropertyMetadata } from "./PropertyMetadata";
import { AnchoredCategorySeriesView } from "./AnchoredCategorySeriesView";
import { ISortingAxis_$type } from "./ISortingAxis";
import { Color } from "./Color";
export class LineSeries extends HorizontalAnchoredCategorySeries {
    constructor() {
        super();
        this.pw = null;
        this.pw = new CategoryLineRasterizer();
        this.ab = LineSeries.$;
        this.pg = 0;
    }
    be() {
        return new LineSeriesView(this);
    }
    h9(a) {
        super.h9(a);
        this.px = a;
    }
    get_ci() {
        return true;
    }
    get ci() {
        return this.get_ci();
    }
    preferredCategoryMode(a) {
        return this.pg;
    }
    he(a, b) {
        super.he(a, b);
        let c = b;
        c.c5();
    }
    n2(a, b) {
        super.n2(a, b);
        let c = b.cl.d;
        let d = typeCast(LineSeriesView.$, b);
        let e = a.f;
        let f = this.getEffectiveViewport1(b);
        this.mt.x(this, this.ne(), this.pd, runOn(this, this.mf), this.nm(b), this.nn(b));
        let g = false;
        let h = this.mt.c;
        if (h != null) {
            g = true;
        }
        if (g) {
            let i = new ScalerParams(0, b.bq, b.bp, this.pd.bz, f);
            this.ny(e, -1, this.valueColumn.count, this.pd, i, b.n);
        }
        let j = d.db;
        let k = d.dc;
        let l = d.da;
        this.mt.ae(j, true, false, true, false);
        this.mt.ae(k, true, false, true, false);
        this.mt.ae(l, false, true, false, false);
        l._opacity = 0.75 * this.mt.i;
        if (b.cp(a)) {
            d.c6(e.count, e, true, this.unknownValuePlotting, this.oc(e, e.count - 1, b.bp, b.bq), c, this.ej);
            b.cs(a);
        }
    }
    ie(a, b, c, d) {
        super.ie(a, b, c, d);
        switch (b) {
            case LineSeries.$$p[0]:
                this.mq.m = this.unknownValuePlotting == 0;
                this.it(false);
                this.h1();
                break;
        }
    }
    get useHighMarkerFidelity() {
        return this.nh;
    }
}
LineSeries.$t = markType(LineSeries, 'LineSeries', HorizontalAnchoredCategorySeries.$, [IUnknownValuePlotting_$type]);
Type.dep(DependencyProperty, PropertyMetadata, LineSeries, 'raisePropertyChanged', ['UnknownValuePlotting::pz', [UnknownValuePlotting_$type, enumGetBox(UnknownValuePlotting_$type, 1)]]);
export class LineSeriesView extends AnchoredCategorySeriesView {
    constructor(a) {
        super(a);
        this.c4 = null;
        this.de = new Path();
        this.dd = new Path();
        this.df = new Path();
        this.c9 = new Path();
        this.c8 = new Path();
        this.c7 = new Path();
        this.c4 = a;
    }
    get db() {
        return this.de;
    }
    get dc() {
        return this.df;
    }
    get da() {
        return this.dd;
    }
    c5() {
        this.dd.aj = null;
        this.de.aj = null;
        this.df.aj = null;
        this.an();
    }
    c6(a, b, c, d, e, f, g) {
        this.c4.pw.a = typeCast(ISortingAxis_$type, this.cn.fetchXAxis()) !== null ? true : false;
        this.c4.pw.m(this.de, this.dd, this.df, a, b, c, d, e, f, g);
        this.an();
    }
    a8() {
        super.a8();
    }
    a9() {
        super.a9();
        this.c8.aj = this.de.aj;
        this.c9.aj = this.df.aj;
        this.c7.aj = this.dd.aj;
        let a = this.bk();
        this.c8._stroke = a;
        this.c8.ac = this.e.en + 3;
        this.c9._stroke = a;
        this.c9.ac = this.e.en + 3;
        this.c7._fill = a;
        this.c7._opacity = 1;
    }
    a3(a, b) {
        super.a3(a, b);
        if (a.d) {
            if (b) {
                a.s(this.c7);
                a.s(this.c8);
                a.s(this.c9);
            }
            else {
                a.s(this.dd);
                a.s(this.de);
                a.s(this.df);
            }
        }
    }
    ai(a) {
        super.ai(a);
        this.e.a1.exportPathData(a, this.de, "lowerShape", ["Lower", "Main"]);
        this.e.a1.exportPathData(a, this.df, "upperShape", ["Upper"]);
        this.e.a1.exportPathData(a, this.dd, "translucentShape", ["Translucent"]);
    }
    ac() {
        let a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.kp = a;
        this.e.ek = 3;
        this.e.el = 1;
        this.e.em = 4;
        this.e.dq = false;
    }
}
LineSeriesView.$t = markType(LineSeriesView, 'LineSeriesView', AnchoredCategorySeriesView.$);
/*<BeginStatics Name="Infragistics.Controls.Charts.LineSeries" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.LineSeries" />*/
//# sourceMappingURL=LineSeries_combined.js.map