import { StraightNumericAxisBase } from "./StraightNumericAxisBase";
import { IScaler } from "./IScaler";
import { AxisOrientation } from "./AxisOrientation";
import { AxisView } from "./AxisView";
import { Type, IList$1 } from "./type";
import { AxisLabelPanelBase } from "./AxisLabelPanelBase";
import { Rect } from "./Rect";
import { ScalerParams } from "./ScalerParams";
import { NumericScaler } from "./NumericScaler";
import { NumericAxisRenderer } from "./NumericAxisRenderer";
import { NumericAxisRenderingParameters } from "./NumericAxisRenderingParameters";
import { StraightNumericAxisBaseView } from "./StraightNumericAxisBaseView";
export declare class NumericYAxis extends StraightNumericAxisBase implements IScaler {
    ax(): AxisView;
    constructor();
    ao(): AxisLabelPanelBase;
    protected get_b5(): boolean;
    readonly b5: boolean;
    di(): number;
    dj(a: number, b: ScalerParams): number;
    f0(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    fz(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    dm(a: number, b: ScalerParams): number;
    f1(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    k7(a: number, b: number): void;
    ip(): NumericAxisRenderer;
    is(a: Rect, b: Rect, c: Rect, d: Rect): NumericAxisRenderingParameters;
    protected gk(a: boolean): void;
    protected gu(a: Rect, b: Rect): void;
    protected get_av(): AxisOrientation;
    readonly av: AxisOrientation;
    iu(): NumericScaler;
    j$c(a: number, b: ScalerParams): number;
    j$b(a: number, b: ScalerParams): number;
    j$d(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    j$e(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    j$f(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    readonly j$a: boolean;
    static $t: Type;
}
export declare class NumericYAxisView extends StraightNumericAxisBaseView {
    constructor(a: NumericYAxis);
    protected bc: NumericYAxis;
    static $t: Type;
}
