/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { FrameworkElement } from "./FrameworkElement";
import { INotifyPropertyChanged_$type, PropertyChangedEventArgs, Type, markType } from "./type";
import { DependencyProperty } from "./DependencyProperty";
import { PropertyUpdatedEventArgs } from "./PropertyUpdatedEventArgs";
import { PropertyMetadata } from "./PropertyMetadata";
export class SyncSettings extends FrameworkElement {
    constructor() {
        super(...arguments);
        this.propertyChanged = null;
        this.propertyUpdated = null;
    }
    ai(a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        if (this.propertyUpdated != null) {
            this.propertyUpdated(this, new PropertyUpdatedEventArgs(a, b, c));
        }
    }
}
SyncSettings.$t = markType(SyncSettings, 'SyncSettings', FrameworkElement.$, [INotifyPropertyChanged_$type]);
Type.dep(DependencyProperty, PropertyMetadata, SyncSettings, 'ai', ['SyncChannel:ae:aj', [2, null], 'SynchronizeHorizontally:ac:ak', [0, true], 'SynchronizeVertically:ad:al', [0, true]]);
/*<BeginStatics Name="Infragistics.Controls.Charts.SyncSettings" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.SyncSettings" />*/
//# sourceMappingURL=SyncSettings.js.map