import { HorizontalAnchoredCategorySeries } from "./HorizontalAnchoredCategorySeries";
import { Brush } from "./Brush";
import { SeriesView } from "./SeriesView";
import { Type, Point } from "./type";
import { CategoryMode } from "./CategoryMode";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { Rect } from "./Rect";
import { Pool$1 } from "./Pool$1";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { CategoryFrame } from "./CategoryFrame";
import { CategorySeriesView } from "./CategorySeriesView";
import { Rectangle } from "./Rectangle";
import { List$1 } from "./List$1";
import { AnchoredCategorySeriesView } from "./AnchoredCategorySeriesView";
import { RenderingContext } from "./RenderingContext";
export declare class WaterfallSeries extends HorizontalAnchoredCategorySeries {
    protected be(): SeriesView;
    h9(a: SeriesView): void;
    pw: WaterfallSeriesView;
    constructor();
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    protected get_cx(): boolean;
    readonly cx: boolean;
    iy(a: Brush, b: Brush): void;
    p7: Brush;
    ko(): Brush;
    px: number;
    py: number;
    protected get_na(): boolean;
    protected readonly na: boolean;
    protected ie(a: any, b: string, c: any, d: any): void;
    dd(a: Point, b: boolean): boolean;
    k9(a: Point): Rect;
    private p9(a);
    protected mv(): CategoryTransitionInMode;
    he(a: boolean, b: SeriesView): void;
    d7(): number;
    n2(a: CategoryFrame, b: CategorySeriesView): void;
    p8: Brush;
    readonly useHighMarkerFidelity: boolean;
    static $$p: string[];
    static $t: Type;
}
export declare class WaterfallSeriesView extends AnchoredCategorySeriesView {
    ap(): void;
    protected c4: WaterfallSeries;
    constructor(a: WaterfallSeries);
    de(): Rectangle;
    protected c6: List$1<Rectangle>;
    c7(a: Rectangle): void;
    c9(a: Rectangle): void;
    c8(a: Rectangle): void;
    da(a: Rectangle, b: number, c: number): void;
    protected z(a: number): any;
    private dd;
    protected y(a: number): any;
    protected a3(a: RenderingContext, b: boolean): void;
    c5: Pool$1<Rectangle>;
    ai(a: any): void;
    db(a: number): Rect;
    dc(a: Rectangle): Rect;
    static $t: Type;
}
