import { Type } from '@angular/core';
import { IgxLegendBaseComponent } from './igx-legend-base-component';
import { ItemLegend } from "./ItemLegend";
/**
 * Represents a legend that displays an item for each point in the series.
*
* You can use the `IgxItemLegendComponent` to display a legend item for each data member bound to the `IgxItemLegendComponent`
*/
export declare const IgxItemLegendComponent_PROVIDERS: {
    provide: typeof IgxLegendBaseComponent;
    useExisting: Type<any>;
}[];
export declare class IgxItemLegendComponent extends IgxLegendBaseComponent {
    protected createImplementation(): ItemLegend;
    readonly i: ItemLegend;
    constructor();
}
