/**
 * Class containing several properties which are used as parameters passed to scaling operations in a SeriesViewer.
*
* Class containing several properties which are used as parameters passed to scaling operations in a `ScalerParams`.
*/
export class ScalerParams {
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    get referenceValue() {
        return this.i.b;
    }
    set referenceValue(v) {
        this.i.b = +v;
    }
}
//# sourceMappingURL=igx-scaler-params.js.map