import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { IgxZoomSliderComponent } from './igx-zoom-slider-component';
import { IgxZoomSliderModule } from './igx-zoom-slider-module';
import { ZoomSlider } from './ZoomSlider';
import { TypeRegistrar } from './type';
export class IgxZoomSliderDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxZoomSliderComponent", IgxZoomSliderComponent);
        TypeRegistrar.register("ZoomSlider", ZoomSlider.$type);
    }
}
IgxZoomSliderDynamicModule.decorators = [
    { type: NgModule, args: [{
                declarations: [],
                exports: [],
                imports: [CommonModule, IgxZoomSliderModule],
                entryComponents: [IgxZoomSliderComponent]
            },] },
];
/** @nocollapse */
IgxZoomSliderDynamicModule.ctorParameters = () => [];
//# sourceMappingURL=igx-zoom-slider-dynamic-module.js.map