/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { Base, markType } from "./type";
var EventProxy = /** @class */ (function (_super) {
    tslib_1.__extends(EventProxy, _super);
    function EventProxy() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.onMouseWheel = null;
        _this.onPinchStarted = null;
        _this.onPinchDelta = null;
        _this.onGestureCompleted = null;
        _this.onZoomStarted = null;
        _this.onZoomDelta = null;
        _this.onZoomCompleted = null;
        _this.onFlingStarted = null;
        _this.onContactStarted = null;
        _this.onDragStarted = null;
        _this.onContactMoved = null;
        _this.onDragDelta = null;
        _this.onContactCompleted = null;
        _this.onDragCompleted = null;
        _this.onMouseLeave = null;
        _this.onMouseOver = null;
        _this.onMouseEnter = null;
        _this.onMouseDown = null;
        _this.onMouseUp = null;
        _this.onDoubleTap = null;
        _this.onHold = null;
        _this.onKeyDown = null;
        _this.onKeyUp = null;
        _this.ba = null;
        _this.a7 = 0;
        _this.af = false;
        _this.ah = null;
        _this.aj = null;
        _this.y = false;
        _this.z = false;
        _this.ai = null;
        return _this;
    }
    EventProxy.prototype.get_ag = function () {
        return false;
    };
    Object.defineProperty(EventProxy.prototype, "ag", {
        get: function () {
            return this.get_ag();
        },
        enumerable: true,
        configurable: true
    });
    EventProxy.prototype.ae = function (a, b) {
        if (this.onMouseWheel != null && !this.aa) {
            return this.onMouseWheel(a, b);
        }
        return false;
    };
    EventProxy.prototype.a2 = function (a, b) {
        if (this.onPinchStarted != null && !this.aa) {
            this.onPinchStarted(a, b);
        }
    };
    EventProxy.prototype.a5 = function (a, b, c, d) {
        if (this.onZoomStarted != null && !this.aa) {
            this.onZoomStarted(a, b, c, d);
        }
    };
    EventProxy.prototype.ab = function (a, b, c) {
        if (this.onFlingStarted != null && !this.aa) {
            return this.onFlingStarted(a, b, c);
        }
        return true;
    };
    EventProxy.prototype.a1 = function (a, b) {
        if (this.onPinchDelta != null && !this.aa) {
            this.onPinchDelta(a, b);
        }
    };
    EventProxy.prototype.a4 = function (a, b, c, d) {
        if (this.onZoomDelta != null && !this.aa) {
            this.onZoomDelta(a, b, c, d);
        }
    };
    EventProxy.prototype.a3 = function (a, b, c, d) {
        if (this.onZoomCompleted != null && !this.aa) {
            this.onZoomCompleted(a, b, c, d);
        }
    };
    EventProxy.prototype.au = function (a, b) {
        if (this.onGestureCompleted != null && !this.aa) {
            this.onGestureCompleted(a, b);
        }
    };
    EventProxy.prototype.ap = function (a, b) {
        if (this.onContactStarted != null && !this.aa) {
            this.onContactStarted(a, b);
        }
    };
    EventProxy.prototype.at = function (a) {
        if (this.onDragStarted != null && !this.aa) {
            this.onDragStarted(a);
        }
    };
    EventProxy.prototype.ao = function (a, b) {
        if (this.onContactMoved != null && !this.aa) {
            this.onContactMoved(a, b);
        }
    };
    EventProxy.prototype.as = function (a) {
        if (this.onDragDelta != null && !this.aa) {
            this.onDragDelta(a);
        }
    };
    EventProxy.prototype.an = function (a, b) {
        if (this.onContactCompleted != null && !this.aa) {
            this.onContactCompleted(a, b);
        }
    };
    EventProxy.prototype.ar = function (a) {
        if (this.onDragCompleted != null && !this.aa) {
            this.onDragCompleted(a);
        }
    };
    EventProxy.prototype.ay = function (a) {
        if (this.onMouseLeave != null && !this.aa) {
            this.onMouseLeave(a);
        }
    };
    EventProxy.prototype.az = function (a, b, c) {
        if (this.onMouseOver != null && !this.aa) {
            this.onMouseOver(a, b, c);
        }
    };
    EventProxy.prototype.ax = function (a) {
        if (this.onMouseEnter != null && !this.aa) {
            this.onMouseEnter(a);
        }
    };
    EventProxy.prototype.aw = function (a) {
        if (this.onMouseDown != null && !this.aa) {
            this.onMouseDown(a);
        }
    };
    EventProxy.prototype.a0 = function (a) {
        if (this.onMouseUp != null && !this.aa) {
            this.onMouseUp(a);
        }
    };
    EventProxy.prototype.ac = function (a) {
        if (this.onKeyDown != null && !this.aa) {
            return this.onKeyDown(a);
        }
        return false;
    };
    EventProxy.prototype.ad = function (a) {
        if (this.onKeyUp != null && !this.aa) {
            return this.onKeyUp(a);
        }
        return false;
    };
    EventProxy.prototype.aq = function (a) {
        if (this.onDoubleTap != null && !this.aa) {
            this.onDoubleTap(a);
        }
    };
    EventProxy.prototype.av = function (a) {
        if (this.onHold != null && !this.aa) {
            this.onHold(a);
        }
    };
    Object.defineProperty(EventProxy.prototype, "aa", {
        get: function () {
            return this.y;
        },
        set: function (a) {
            this.y = a;
            this.am();
        },
        enumerable: true,
        configurable: true
    });
    EventProxy.prototype.am = function () {
    };
    EventProxy.$t = markType(EventProxy, 'EventProxy');
    return EventProxy;
}(Base));
export { EventProxy };
//# sourceMappingURL=EventProxy.js.map