import { SyncableObservableCollection$2 } from './SyncableObservableCollection$2';
export declare abstract class IgxCollection<T, T2> {
    item(index: number, value?: T): T;
    indexOf(item: T): number;
    insert(index: number, item: T): void;
    removeAt(index: number): void;
    readonly count: number;
    add(item: T): void;
    clear(): void;
    contains(item: T): boolean;
    remove(item: T): boolean;
    [Symbol.iterator](): IterableIterator<any>;
    private _setSyncTarget(list);
    private _isIgxCollection;
    private _inner;
    private _innerColl;
    private _fromInner(inner);
    protected _ensureOuter(item: any): any;
    protected _splitOuter(item: string): string[];
    private _fromOuter(outer);
    protected abstract _createInnerColl(): SyncableObservableCollection$2<T, T2>;
    constructor();
}
