import { RectangleVisualData } from "./RectangleVisualData";
import { PolygonVisualData } from "./PolygonVisualData";
import { PolyLineVisualData } from "./PolyLineVisualData";
import { List$1 } from "./List$1";
import { RectData } from "./RectData";
import { Base, Type } from "./type";
export declare class PointerTooltipVisualData extends Base {
    private _boxShape;
    boxShape: RectangleVisualData;
    private _pointerFillShape;
    pointerFillShape: PolygonVisualData;
    private _pointerOutlineShape;
    pointerOutlineShape: PolyLineVisualData;
    private _offsetX;
    offsetX: number;
    private _offsetY;
    offsetY: number;
    private _categoryNames;
    categoryNames: List$1<string>;
    serialize(): string;
    scaleByViewport(a: RectData): void;
    private _viewport;
    viewport: RectData;
    static $t: Type;
}
