/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { HorizontalAxisLabelPanelBase } from "./HorizontalAxisLabelPanelBase";
import { Number_$type, fromEnum, markType } from "./type";
import { Size } from "./Size";
import { List$1 } from "./List$1";
import { Rect } from "./Rect";
import { HorizontalAxisLabelPanelBaseView } from "./HorizontalAxisLabelPanelBaseView";
import { TransformGroup } from "./TransformGroup";
import { RotateTransform } from "./RotateTransform";
import { TranslateTransform } from "./TranslateTransform";
import { ViewportUtils } from "./ViewportUtils";
var RadialAxisLabelPanel = /** @class */ (function (_super) {
    tslib_1.__extends(RadialAxisLabelPanel, _super);
    function RadialAxisLabelPanel() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.de = null;
        _this.db = 0;
        _this.da = new List$1(Number_$type, 0);
        return _this;
    }
    RadialAxisLabelPanel.prototype.ad = function () {
        return new RadialAxisLabelPanelView(this);
    };
    RadialAxisLabelPanel.prototype.b6 = function (a) {
        _super.prototype.b6.call(this, a);
        this.c7 = a;
    };
    Object.defineProperty(RadialAxisLabelPanel.prototype, "c9", {
        get: function () {
            return this.ac.as != null && (this.ac.as.c != 5 && this.ac.as.c != 4);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RadialAxisLabelPanel.prototype, "c8", {
        get: function () {
            return !this.c9;
        },
        enumerable: true,
        configurable: true
    });
    RadialAxisLabelPanel.prototype.ct = function () {
        return this.am && (!this.ap || this.bb() == -180);
    };
    RadialAxisLabelPanel.prototype.cu = function () {
        return !this.aq;
    };
    RadialAxisLabelPanel.prototype.br = function (a) {
        _super.prototype.br.call(this, a);
        if (this.db % 360 == 0 || this.c9) {
            this.c7.a2();
        }
        else {
            this.c7.a1(a);
        }
    };
    RadialAxisLabelPanel.prototype.bb = function () {
        var a = _super.prototype.bb.call(this);
        if (this.c8) {
            a -= (this.db * 180) / Math.PI;
        }
        return a;
    };
    RadialAxisLabelPanel.prototype.cs = function () {
        return this.bb() % 360 != 0;
    };
    RadialAxisLabelPanel.prototype.cr = function () {
        if (this.c9) {
            return true;
        }
        var a = this.db * 180 / Math.PI;
        if (a < 30 || a > 330 || (a > 150 && a < 210)) {
            return true;
        }
        return false;
    };
    RadialAxisLabelPanel.prototype.b9 = function (a, b) {
        var c = b * Math.PI / 180;
        var d = Math.abs(Math.sin(c));
        if (this.ac.as != null && this.ac.as.c == 4) {
            d = d * -1;
        }
        this.c7.a3(a, b, d);
    };
    RadialAxisLabelPanel.prototype.dd = function () {
        var a = 1.7976931348623157E+308;
        try {
            for (var _a = tslib_1.__values(fromEnum(this.a2)), _b = _a.next(); !_b.done; _b = _a.next()) {
                var b = _b.value;
                a = Math.min(b.a, a);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return a;
        var e_1, _c;
    };
    RadialAxisLabelPanel.prototype.dc = function () {
        var a = -1.7976931348623157E+308;
        try {
            for (var _a = tslib_1.__values(fromEnum(this.a2)), _b = _a.next(); !_b.done; _b = _a.next()) {
                var b = _b.value;
                a = Math.max(b.a, a);
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_2) throw e_2.error; }
        }
        return a;
        var e_2, _c;
    };
    RadialAxisLabelPanel.prototype.c5 = function (a) {
        var b;
        if (this.ac.bz) {
            b = this.dd();
        }
        else {
            b = this.dc();
        }
        var c = new List$1(Number_$type, 0);
        for (var d = 0; d < this.a2.count; d++) {
            var e = this.a2._inner[d];
            if (e.a == b) {
                c.add(this.a2.indexOf(e));
            }
        }
        this.da = c;
        var f = new List$1(Rect.$, 0);
        for (var g = 0; g < a.count; g++) {
            var h = a._inner[g];
            if (!this.da.contains(g)) {
                f.add(h);
            }
        }
        this.am = this.al(f);
    };
    RadialAxisLabelPanel.prototype.ao = function (a, b) {
        if (this.da.contains(a)) {
            return false;
        }
        else {
            return _super.prototype.ao.call(this, a, b);
        }
    };
    RadialAxisLabelPanel.prototype.c6 = function () {
        this.da = new List$1(Number_$type, 0);
        _super.prototype.c6.call(this);
    };
    RadialAxisLabelPanel.prototype.ah = function () {
        return 5;
    };
    RadialAxisLabelPanel.prototype.as = function (a) {
        return a == 5 || a == 4 || a == 1 || a == 0;
    };
    RadialAxisLabelPanel.prototype.by = function () {
    };
    RadialAxisLabelPanel.$t = markType(RadialAxisLabelPanel, 'RadialAxisLabelPanel', HorizontalAxisLabelPanelBase.$);
    return RadialAxisLabelPanel;
}(HorizontalAxisLabelPanelBase));
export { RadialAxisLabelPanel };
var RadialAxisLabelPanelView = /** @class */ (function (_super) {
    tslib_1.__extends(RadialAxisLabelPanelView, _super);
    function RadialAxisLabelPanelView(a) {
        var _this = _super.call(this, a) || this;
        _this.a0 = null;
        _this.a0 = a;
        return _this;
    }
    RadialAxisLabelPanelView.prototype.a3 = function (a, b, c) {
        var d = this.m(a);
        var e = this.l(a);
        var f = new TransformGroup();
        f.j.add(((function () {
            var $ret = new RotateTransform();
            $ret.j = b;
            $ret.k = d / 2;
            $ret.l = e / 2;
            return $ret;
        })()));
        f.j.add(((function () {
            var $ret = new TranslateTransform();
            $ret.j = d / -2;
            $ret.k = d / 2 * c;
            return $ret;
        })()));
        a.j = f;
    };
    RadialAxisLabelPanelView.prototype.a2 = function () {
        this.a.j = null;
    };
    RadialAxisLabelPanelView.prototype.a1 = function (a) {
        var _this = this;
        var b = ViewportUtils.f(0.5, this.a.cn, this.a.cm);
        this.a.j = ((function () {
            var $ret = new RotateTransform();
            $ret.j = (_this.a0.db * 180) / Math.PI;
            $ret.k = _this.a0.de.x;
            $ret.l = (_this.a0.de.y * a.height) + b;
            return $ret;
        })());
    };
    RadialAxisLabelPanelView.prototype.ak = function () {
        _super.prototype.ak.call(this);
        this.a.co(new Size(1, this.a.cl.width, this.a.cl.height));
    };
    RadialAxisLabelPanelView.$t = markType(RadialAxisLabelPanelView, 'RadialAxisLabelPanelView', HorizontalAxisLabelPanelBaseView.$);
    return RadialAxisLabelPanelView;
}(HorizontalAxisLabelPanelBaseView));
export { RadialAxisLabelPanelView };
//# sourceMappingURL=RadialAxisLabelPanel_combined.js.map