import { SplineSeriesBase } from "./SplineSeriesBase";
import { CategoryLineRasterizer } from "./CategoryLineRasterizer";
import { SeriesView } from "./SeriesView";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { Type, Point } from "./type";
import { CategoryMode } from "./CategoryMode";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { CategoryFrame } from "./CategoryFrame";
import { CategorySeriesView } from "./CategorySeriesView";
import { List$1 } from "./List$1";
import { Path } from "./Path";
import { PointCollection } from "./PointCollection";
import { UnknownValuePlotting } from "./UnknownValuePlotting";
import { SplineSeriesBaseView } from "./SplineSeriesBaseView";
import { Clipper } from "./Clipper";
import { RenderingContext } from "./RenderingContext";
export declare class SplineAreaSeries extends SplineSeriesBase {
    protected be(): SeriesView;
    protected mv(): CategoryTransitionInMode;
    h9(a: SeriesView): void;
    p7: SplineAreaSeriesView;
    constructor();
    p6: CategoryLineRasterizer;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    he(a: boolean, b: SeriesView): void;
    dd(a: Point, b: boolean): boolean;
    n2(a: CategoryFrame, b: CategorySeriesView): void;
    readonly useHighMarkerFidelity: boolean;
    static $t: Type;
}
export declare class SplineAreaSeriesView extends SplineSeriesBaseView {
    protected c5: SplineAreaSeries;
    constructor(a: SplineAreaSeries);
    ap(): void;
    private df;
    private dj;
    private dh;
    private dk;
    readonly dd: Path;
    readonly de: Path;
    readonly dg: Path;
    readonly di: Path;
    c6(): void;
    c7(a: number, b: List$1<number[]>, c: boolean, d: number, e: number, f: (arg1: PointCollection, arg2: PointCollection, arg3: PointCollection, arg4: PointCollection, arg5: boolean) => void, g: UnknownValuePlotting): void;
    c8(a: number, b: List$1<number[]>, c: boolean, d: number, e: number, f: (arg1: PointCollection, arg2: PointCollection, arg3: PointCollection, arg4: PointCollection, arg5: boolean) => void, g: UnknownValuePlotting, h: Clipper): void;
    private c9;
    private db;
    private da;
    private dc;
    protected a9(): void;
    protected a3(a: RenderingContext, b: boolean): void;
    ai(a: any): void;
    protected ac(): void;
    static $t: Type;
}
