import { SplineSeriesBase } from "./SplineSeriesBase";
import { CategoryLineRasterizer } from "./CategoryLineRasterizer";
import { SeriesView } from "./SeriesView";
import { Type } from "./type";
import { CategoryMode } from "./CategoryMode";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { CategoryFrame } from "./CategoryFrame";
import { CategorySeriesView } from "./CategorySeriesView";
import { List$1 } from "./List$1";
import { Path } from "./Path";
import { UnknownValuePlotting } from "./UnknownValuePlotting";
import { SplineSeriesBaseView } from "./SplineSeriesBaseView";
import { Clipper } from "./Clipper";
import { RenderingContext } from "./RenderingContext";
export declare class SplineSeries extends SplineSeriesBase {
    protected be(): SeriesView;
    h9(a: SeriesView): void;
    p7: SplineSeriesView;
    constructor();
    p6: CategoryLineRasterizer;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    he(a: boolean, b: SeriesView): void;
    n2(a: CategoryFrame, b: CategorySeriesView): void;
    readonly useHighMarkerFidelity: boolean;
    static $t: Type;
}
export declare class SplineSeriesView extends SplineSeriesBaseView {
    protected c5: SplineSeries;
    constructor(a: SplineSeries);
    private df;
    private de;
    private dg;
    readonly dc: Path;
    readonly dd: Path;
    readonly db: Path;
    c6(): void;
    c7(a: number, b: List$1<number[]>, c: boolean, d: UnknownValuePlotting, e: Clipper, f: number, g: number): void;
    private da;
    private c9;
    private c8;
    protected a9(): void;
    protected a3(a: RenderingContext, b: boolean): void;
    ai(a: any): void;
    static $t: Type;
}
