/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { DomainChart } from "./DomainChart";
import { HorizontalAlignment_$type } from "./HorizontalAlignment";
import { VerticalAlignment_$type } from "./VerticalAlignment";
import { Visibility_$type } from "./Visibility";
import { AxisLabelsLocation_$type } from "./AxisLabelsLocation";
import { fromEnum, enumGetBox, markType } from "./type";
import { TitleSettings } from "./TitleSettings";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { ScalerParams } from "./ScalerParams";
var XYChart = /** @class */ (function (_super) {
    tslib_1.__extends(XYChart, _super);
    function XYChart() {
        var _this = _super.call(this) || this;
        _this.gl = null;
        _this.gm = null;
        _this.gy = 0;
        _this.g0 = 5;
        _this.gz = 0;
        _this.gx = 5;
        _this.hf = 5;
        _this.hh = 0;
        _this.hg = 5;
        _this.he = 0;
        _this.lu = null;
        _this.l1 = null;
        _this.g9 = 0;
        _this.hq = 0;
        _this.g8 = NaN;
        _this.hp = NaN;
        _this.hb = NaN;
        _this.hs = NaN;
        _this.ha = NaN;
        _this.hr = NaN;
        _this.g7 = NaN;
        _this.ho = NaN;
        _this.l0 = null;
        _this.l7 = null;
        _this.i1 = null;
        _this.i4 = null;
        _this.i3 = null;
        _this.i6 = null;
        _this.ix = null;
        _this.iy = null;
        _this.lv = null;
        _this.l2 = null;
        _this.g1 = 1;
        _this.hi = 1;
        _this.g2 = 1;
        _this.hj = 0;
        _this.lx = null;
        _this.l4 = null;
        _this.ly = null;
        _this.l5 = null;
        _this.g3 = 1;
        _this.hk = 1;
        _this.g4 = 5;
        _this.hl = 0;
        _this.lz = null;
        _this.l6 = null;
        _this.g5 = 2;
        _this.hm = 2;
        _this.i2 = null;
        _this.i5 = null;
        _this.lw = null;
        _this.l3 = null;
        _this.gw = 0;
        _this.hd = 0;
        _this.gv = NaN;
        _this.hc = NaN;
        _this.g6 = 0;
        _this.hn = -90;
        _this.gr = false;
        _this.gs = false;
        _this.lp = 1;
        _this.mo = 1;
        _this.lo = 1;
        _this.lq = 2;
        _this.mm = 0;
        _this.mn = 1;
        _this.ms = 0;
        _this.mt = 0;
        _this.gp = 2;
        return _this;
    }
    XYChart.prototype.fj = function (a, b, c) {
        var _this = this;
        _super.prototype.fj.call(this, a, b, c);
        switch (a) {
            case "XAxisLabelLeftMargin":
                this.li(function (d) { return d.leftMargin = _this.h0; });
                break;
            case "XAxisLabelTopMargin":
                this.li(function (d) { return d.topMargin = _this.h2; });
                break;
            case "XAxisLabelRightMargin":
                this.li(function (d) { return d.rightMargin = _this.h1; });
                break;
            case "XAxisLabelBottomMargin":
                this.li(function (d) { return d.bottomMargin = _this.hz; });
                break;
            case "YAxisLabelLeftMargin":
                this.lm(function (d) { return d.leftMargin = _this.ii; });
                break;
            case "YAxisLabelTopMargin":
                this.lm(function (d) { return d.topMargin = _this.ik; });
                break;
            case "YAxisLabelRightMargin":
                this.lm(function (d) { return d.rightMargin = _this.ij; });
                break;
            case "YAxisLabelBottomMargin":
                this.lm(function (d) { return d.bottomMargin = _this.ih; });
                break;
            case "XAxisLabelTextColor":
                this.li(function (d) { return d.textColor = _this.l8; });
                break;
            case "YAxisLabelTextColor":
                this.lm(function (d) { return d.textColor = _this.mf; });
                break;
            case "XAxisTitleMargin":
                this.lj(function (d) { return d.margin = _this.ib; });
                break;
            case "YAxisTitleMargin":
                this.ln(function (d) { return d.margin = _this.iu; });
                break;
            case "XAxisTitleLeftMargin":
                this.lj(function (d) { return d.leftMargin = _this.ia; });
                break;
            case "YAxisTitleLeftMargin":
                this.ln(function (d) { return d.leftMargin = _this.it; });
                break;
            case "XAxisTitleTopMargin":
                this.lj(function (d) { return d.topMargin = _this.id; });
                break;
            case "YAxisTitleTopMargin":
                this.ln(function (d) { return d.topMargin = _this.iw; });
                break;
            case "XAxisTitleRightMargin":
                this.lj(function (d) { return d.rightMargin = _this.ic; });
                break;
            case "YAxisTitleRightMargin":
                this.ln(function (d) { return d.rightMargin = _this.iv; });
                break;
            case "XAxisTitleBottomMargin":
                this.lj(function (d) { return d.bottomMargin = _this.h9; });
                break;
            case "YAxisTitleBottomMargin":
                this.ln(function (d) { return d.bottomMargin = _this.is; });
                break;
            case "XAxisTitleTextColor":
                this.lj(function (d) { return d.textColor = _this.me; });
                break;
            case "YAxisTitleTextColor":
                this.ln(function (d) { return d.textColor = _this.ml; });
                break;
            case "XAxisFormatLabel":
                this.lh(function (d) { return d.an = _this.gn; });
                break;
            case "YAxisFormatLabel":
                this.lk(function (d) { return d.an = _this.go; });
                break;
        }
    };
    Object.defineProperty(XYChart.prototype, "gn", {
        get: function () {
            return this.gl;
        },
        set: function (a) {
            var b = this.gn;
            if (a != b) {
                this.gl = a;
                this.fi("XAxisFormatLabel", b, this.gn);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "go", {
        get: function () {
            return this.gm;
        },
        set: function (a) {
            var b = this.go;
            if (a != b) {
                this.gm = a;
                this.fi("YAxisFormatLabel", b, this.go);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "h0", {
        get: function () {
            return this.gy;
        },
        set: function (a) {
            var b = this.h0;
            if (a != b) {
                this.gy = a;
                this.fi("XAxisLabelLeftMargin", b, this.h0);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "h2", {
        get: function () {
            return this.g0;
        },
        set: function (a) {
            var b = this.h2;
            if (a != b) {
                this.g0 = a;
                this.fi("XAxisLabelTopMargin", b, this.h2);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "h1", {
        get: function () {
            return this.gz;
        },
        set: function (a) {
            var b = this.h1;
            if (a != b) {
                this.gz = a;
                this.fi("XAxisLabelRightMargin", b, this.h1);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "hz", {
        get: function () {
            return this.gx;
        },
        set: function (a) {
            var b = this.hz;
            if (a != b) {
                this.gx = a;
                this.fi("XAxisLabelBottomMargin", b, this.hz);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ii", {
        get: function () {
            return this.hf;
        },
        set: function (a) {
            var b = this.ii;
            if (a != b) {
                this.hf = a;
                this.fi("YAxisLabelLeftMargin", b, this.ii);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ik", {
        get: function () {
            return this.hh;
        },
        set: function (a) {
            var b = this.ik;
            if (a != b) {
                this.hh = a;
                this.fi("YAxisLabelTopMargin", b, this.ik);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ij", {
        get: function () {
            return this.hg;
        },
        set: function (a) {
            var b = this.ij;
            if (a != b) {
                this.hg = a;
                this.fi("YAxisLabelRightMargin", b, this.ij);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ih", {
        get: function () {
            return this.he;
        },
        set: function (a) {
            var b = this.ih;
            if (a != b) {
                this.he = a;
                this.fi("YAxisLabelBottomMargin", b, this.ih);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "l8", {
        get: function () {
            return this.lu;
        },
        set: function (a) {
            var b = this.l8;
            if (a != b) {
                this.lu = a;
                this.fi("XAxisLabelTextColor", b, this.l8);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "mf", {
        get: function () {
            return this.l1;
        },
        set: function (a) {
            var b = this.mf;
            if (a != b) {
                this.l1 = a;
                this.fi("YAxisLabelTextColor", b, this.mf);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ib", {
        get: function () {
            return this.g9;
        },
        set: function (a) {
            var b = this.ib;
            if (a != b) {
                this.g9 = a;
                this.fi("XAxisTitleMargin", b, this.ib);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "iu", {
        get: function () {
            return this.hq;
        },
        set: function (a) {
            var b = this.iu;
            if (a != b) {
                this.hq = a;
                this.fi("YAxisTitleMargin", b, this.iu);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ia", {
        get: function () {
            return this.g8;
        },
        set: function (a) {
            var b = this.ia;
            if (a != b) {
                this.g8 = a;
                this.fi("XAxisTitleLeftMargin", b, this.ia);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "it", {
        get: function () {
            return this.hp;
        },
        set: function (a) {
            var b = this.it;
            if (a != b) {
                this.hp = a;
                this.fi("YAxisTitleLeftMargin", b, this.it);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "id", {
        get: function () {
            return this.hb;
        },
        set: function (a) {
            var b = this.id;
            if (a != b) {
                this.hb = a;
                this.fi("XAxisTitleTopMargin", b, this.id);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "iw", {
        get: function () {
            return this.hs;
        },
        set: function (a) {
            var b = this.iw;
            if (a != b) {
                this.hs = a;
                this.fi("YAxisTitleTopMargin", b, this.iw);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ic", {
        get: function () {
            return this.ha;
        },
        set: function (a) {
            var b = this.ic;
            if (a != b) {
                this.ha = a;
                this.fi("XAxisTitleRightMargin", b, this.ic);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "iv", {
        get: function () {
            return this.hr;
        },
        set: function (a) {
            var b = this.iv;
            if (a != b) {
                this.hr = a;
                this.fi("YAxisTitleRightMargin", b, this.iv);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "h9", {
        get: function () {
            return this.g7;
        },
        set: function (a) {
            var b = this.h9;
            if (a != b) {
                this.g7 = a;
                this.fi("XAxisTitleBottomMargin", b, this.h9);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "is", {
        get: function () {
            return this.ho;
        },
        set: function (a) {
            var b = this.is;
            if (a != b) {
                this.ho = a;
                this.fi("YAxisTitleBottomMargin", b, this.is);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "me", {
        get: function () {
            return this.l0;
        },
        set: function (a) {
            var b = this.me;
            if (a != b) {
                this.l0 = a;
                this.fi("XAxisTitleTextColor", b, this.me);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ml", {
        get: function () {
            return this.l7;
        },
        set: function (a) {
            var b = this.ml;
            if (a != b) {
                this.l7 = a;
                this.fi("YAxisTitleTextColor", b, this.ml);
            }
        },
        enumerable: true,
        configurable: true
    });
    XYChart.prototype.fk = function (a, b, c) {
        var _this = this;
        _super.prototype.fk.call(this, a, b, c);
        switch (a) {
            case "XAxisLabelTextStyle":
                this.li(function (d) { return d.textStyle = _this.ji; });
                break;
            case "YAxisLabelTextStyle":
                this.lm(function (d) { return d.textStyle = _this.kk; });
                break;
            case "XAxisTitleTextStyle":
                this.lj(function (d) { return d.textStyle = _this.j6; });
                break;
            case "YAxisTitleTextStyle":
                this.ln(function (d) { return d.textStyle = _this.k8; });
                break;
        }
    };
    Object.defineProperty(XYChart.prototype, "ji", {
        get: function () {
            return this.i1;
        },
        set: function (a) {
            var b = this.ji;
            if (a != b) {
                this.i1 = a;
                this.fi("XAxisLabelTextStyle", b, this.ji);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "kk", {
        get: function () {
            return this.i4;
        },
        set: function (a) {
            var b = this.kk;
            if (a != b) {
                this.i4 = a;
                this.fi("YAxisLabelTextStyle", b, this.kk);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "j6", {
        get: function () {
            return this.i3;
        },
        set: function (a) {
            var b = this.j6;
            if (a != b) {
                this.i3 = a;
                this.fi("XAxisTitleTextStyle", b, this.j6);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "k8", {
        get: function () {
            return this.i6;
        },
        set: function (a) {
            var b = this.k8;
            if (a != b) {
                this.i6 = a;
                this.fi("YAxisTitleTextStyle", b, this.k8);
            }
        },
        enumerable: true,
        configurable: true
    });
    XYChart.prototype.le = function (a) {
        var _this = this;
        this.lb(a, function (b) { return b.leftMargin = _this.h0; });
        this.lb(a, function (b) { return b.topMargin = _this.h2; });
        this.lb(a, function (b) { return b.rightMargin = _this.h1; });
        this.lb(a, function (b) { return b.bottomMargin = _this.hz; });
        this.lb(a, function (b) { return b.textColor = _this.l8; });
        this.lb(a, function (b) { return b.textStyle = _this.ji; });
        this.lc(a, function (b) { return b.textColor = _this.me; });
        this.lc(a, function (b) { return b.textStyle = _this.j6; });
        this.lc(a, function (b) { return b.leftMargin = _this.ia; });
        this.lc(a, function (b) { return b.topMargin = _this.id; });
        this.lc(a, function (b) { return b.rightMargin = _this.ic; });
        this.lc(a, function (b) { return b.bottomMargin = _this.h9; });
    };
    XYChart.prototype.lg = function (a) {
        var _this = this;
        this.lb(a, function (b) { return b.leftMargin = _this.ii; });
        this.lb(a, function (b) { return b.topMargin = _this.ik; });
        this.lb(a, function (b) { return b.rightMargin = _this.ij; });
        this.lb(a, function (b) { return b.bottomMargin = _this.ih; });
        this.lb(a, function (b) { return b.textColor = _this.mf; });
        this.lb(a, function (b) { return b.textStyle = _this.kk; });
        this.lc(a, function (b) { return b.textColor = _this.ml; });
        this.lc(a, function (b) { return b.textStyle = _this.k8; });
        this.lc(a, function (b) { return b.leftMargin = _this.it; });
        this.lc(a, function (b) { return b.topMargin = _this.iw; });
        this.lc(a, function (b) { return b.rightMargin = _this.iv; });
        this.lc(a, function (b) { return b.bottomMargin = _this.is; });
    };
    XYChart.prototype.fx = function (a) {
        var b = this.r(a);
        var c = this.ag(a, b);
        if (c == null) {
            return;
        }
        c.itemsSource = a.data;
        c.name = this.c5(a);
        c.fj = this.c6(a, b);
        this.dataChart.series.add(c);
    };
    XYChart.prototype.lh = function (a) {
        a(this.gj());
    };
    XYChart.prototype.ll = function (a, b) {
        a(this.gk());
    };
    XYChart.prototype.lk = function (a) {
        this.ll(a, true);
    };
    XYChart.prototype.lj = function (a) {
        this.lc(this.gj(), a);
    };
    XYChart.prototype.ln = function (a) {
        this.lc(this.gk(), a);
    };
    XYChart.prototype.lm = function (a) {
        this.lb(this.gk(), a);
    };
    XYChart.prototype.li = function (a) {
        this.lb(this.gj(), a);
    };
    XYChart.prototype.ht = function (a) {
        return this.gj().dj(a, new ScalerParams(1, this.gi, this.gh, this.gj().bz));
    };
    XYChart.prototype.hv = function (a) {
        return this.gj().dm(a, new ScalerParams(1, this.gi, this.gh, this.gj().bz));
    };
    XYChart.prototype.hu = function (a) {
        return this.gk().dj(a, new ScalerParams(1, this.gi, this.gh, this.gk().bz));
    };
    XYChart.prototype.hw = function (a) {
        return this.gk().dm(a, new ScalerParams(1, this.gi, this.gh, this.gk().bz));
    };
    XYChart.prototype.fv = function (a) {
        if (a == null) {
            return;
        }
        if (a.axes != null) {
            var b = this.gj();
            var c = this.gk();
            if (a.axes.contains(b)) {
                a.axes.remove(b);
            }
            if (a.axes.contains(c)) {
                a.axes.remove(c);
            }
        }
    };
    XYChart.i7 = function (a, b) {
        try {
            for (var _a = tslib_1.__values(fromEnum(b)), _b = _a.next(); !_b.done; _b = _a.next()) {
                var c = _b.value;
                var d = c.findMatchingHint(16);
                if (d != null) {
                    var e = d.path;
                    return e;
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return null;
        var e_1, _c;
    };
    XYChart.prototype.ew = function (a) {
        _super.prototype.ew.call(this, a);
        if (a == this.dataChart) {
            this.dataChart.axes.add(this.gj());
            this.dataChart.axes.add(this.gk());
        }
    };
    XYChart.prototype.e2 = function (a, b) {
        _super.prototype.e2.call(this, a, b);
    };
    XYChart.prototype.ld = function (a) {
        var _this = this;
        if (a != null && this.cm != null && a.ee == null) {
            a.provideRenderer(this.cm);
        }
        a.hv = this.l9;
        a.dr = this.h3;
        a.hw = this.ma;
        a.du = this.h4;
        a.hy = this.mc;
        a.ea = this.h5;
        a.hx = this.mb;
        a.eb = this.h6;
        a.hz = this.md;
        a.ec = this.h7;
        var b = a == this.gj();
        if (b) {
            a.fp = this.jx;
        }
        this.lb(a, function (c) { return c.angle = _this.hy; });
        this.lb(a, function (c) {
            if (c.extent != _this.hx) {
                c.extent = _this.hx;
            }
        });
        this.lb(a, function (c) { return c.horizontalAlignment = _this.lr; });
        this.lb(a, function (c) { return c.verticalAlignment = _this.mp; });
        this.lb(a, function (c) { return c.visibility = _this.mu; });
        this.lc(a, function (c) { return c.horizontalAlignment = _this.ls; });
        this.lc(a, function (c) { return c.angle = _this.h8; });
        this.le(a);
    };
    XYChart.prototype.lf = function (a) {
        var _this = this;
        if (a == null) {
            return;
        }
        if (this.cm != null && a.ee == null) {
            a.provideRenderer(this.cm);
        }
        this.lb(a, function (b) { return b.angle = _this.ig; });
        this.lb(a, function (b) {
            if (b.extent != _this.ie) {
                b.extent = _this.ie;
            }
        });
        this.lb(a, function (b) { return b.horizontalAlignment = _this.lt; });
        this.lb(a, function (b) { return b.verticalAlignment = _this.mq; });
        this.lb(a, function (b) { return b.visibility = _this.mv; });
        this.lb(a, function (b) { return b.location = _this.gq; });
        this.lc(a, function (b) { return b.verticalAlignment = _this.mr; });
        this.lc(a, function (b) { return b.angle = _this.ir; });
        a.hv = this.mg;
        a.dr = this.il;
        a.hw = this.mh;
        a.du = this.im;
        a.hy = this.mj;
        a.ea = this.io;
        a.hx = this.mi;
        a.eb = this.ip;
        a.hz = this.mk;
        a.ec = this.iq;
        var b = a == this.gk();
        if (b) {
            a.fp = this.kz;
        }
        this.lg(a);
    };
    XYChart.prototype.et = function () {
        _super.prototype.et.call(this);
        this.ld(this.gj());
        this.lf(this.gk());
    };
    XYChart.prototype.lb = function (a, b) {
        if (a == null) {
            return;
        }
        if (a.as == null) {
            a.as = new AxisLabelSettings();
            a.as.angle = a.c8();
            a.as.bottomMargin = a.c9();
            a.as.leftMargin = a.da();
            a.as.rightMargin = a.db();
            a.as.topMargin = a.dc();
            a.as.horizontalAlignment = a.hq();
            a.as.location = a.at();
            a.as.verticalAlignment = a.ij();
        }
        b(a.as);
    };
    XYChart.prototype.lc = function (a, b) {
        if (a == null) {
            return;
        }
        if (a.a6 == null) {
            a.a6 = new TitleSettings();
            a.a6.bottomMargin = a.de();
            a.a6.leftMargin = a.df();
            a.a6.rightMargin = a.dg();
            a.a6.topMargin = a.dh();
            a.a6.location = a.au();
            a.a6.angle = a.dd();
            a.a6.horizontalAlignment = a.hr();
            a.a6.verticalAlignment = a.ik();
        }
        b(a.a6);
    };
    XYChart.prototype.fi = function (a, b, c) {
        var _this = this;
        _super.prototype.fi.call(this, a, b, c);
        switch (a) {
            case "XAxisLabelAngle":
                this.li(function (d) { return d.angle = _this.hy; });
                break;
            case "YAxisLabelAngle":
                this.lm(function (d) { return d.angle = _this.ig; });
                break;
            case "XAxisLabelHorizontalAlignment":
                this.li(function (d) { return d.horizontalAlignment = _this.lr; });
                break;
            case "YAxisLabelHorizontalAlignment":
                this.lm(function (d) { return d.horizontalAlignment = _this.lt; });
                break;
            case "XAxisLabelVerticalAlignment":
                this.li(function (d) { return d.verticalAlignment = _this.mp; });
                break;
            case "YAxisLabelVerticalAlignment":
                this.lm(function (d) { return d.verticalAlignment = _this.mq; });
                break;
            case "XAxisLabelVisibility":
                this.li(function (d) { return d.visibility = _this.mu; });
                break;
            case "YAxisLabelVisibility":
                this.lm(function (d) { return d.visibility = _this.mv; });
                break;
            case "XAxisLabel":
                this.lh(function (d) { return d.er = _this.iz; });
                break;
            case "YAxisLabel":
                this.lk(function (d) { return d.er = _this.i0; });
                break;
            case "XAxisTitleAngle":
                this.lj(function (d) { return d.angle = _this.h8; });
                break;
            case "YAxisTitleAngle":
                this.ln(function (d) { return d.angle = _this.ir; });
                break;
            case "XAxisTitleAlignment":
                this.lj(function (d) { return d.horizontalAlignment = _this.ls; });
                break;
            case "YAxisTitleAlignment":
                this.ln(function (d) { return d.verticalAlignment = _this.mr; });
                break;
            case "XAxisTitle":
                this.lh(function (d) { return d.fp = _this.jx; });
                break;
            case "YAxisTitle":
                this.ll(function (d) { return d.fp = _this.kz; }, false);
                break;
            case "XAxisMajorStroke":
                this.lh(function (d) { return d.hv = _this.l9; });
                break;
            case "YAxisMajorStroke":
                this.lk(function (d) { return d.hv = _this.mg; });
                break;
            case "XAxisMajorStrokeThickness":
                this.lh(function (d) { return d.dr = _this.h3; });
                break;
            case "YAxisMajorStrokeThickness":
                this.lk(function (d) { return d.dr = _this.il; });
                break;
            case "XAxisMinorStroke":
                this.lh(function (d) { return d.hw = _this.ma; });
                break;
            case "YAxisMinorStroke":
                this.lk(function (d) { return d.hw = _this.mh; });
                break;
            case "XAxisMinorStrokeThickness":
                this.lh(function (d) { return d.du = _this.h4; });
                break;
            case "YAxisMinorStrokeThickness":
                this.lk(function (d) { return d.du = _this.im; });
                break;
            case "XAxisTickLength":
                this.lh(function (d) { return d.eb = _this.h6; });
                break;
            case "YAxisTickLength":
                this.lk(function (d) { return d.eb = _this.ip; });
                break;
            case "XAxisTickStroke":
                this.lh(function (d) { return d.hz = _this.md; });
                break;
            case "YAxisTickStroke":
                this.lk(function (d) { return d.hz = _this.mk; });
                break;
            case "XAxisTickStrokeThickness":
                this.lh(function (d) { return d.ec = _this.h7; });
                break;
            case "YAxisTickStrokeThickness":
                this.lk(function (d) { return d.ec = _this.iq; });
                break;
            case "XAxisStroke":
                this.lh(function (d) { return d.hy = _this.mc; });
                break;
            case "YAxisStroke":
                this.lk(function (d) { return d.hy = _this.mj; });
                break;
            case "XAxisStrokeThickness":
                this.lh(function (d) { return d.ea = _this.h5; });
                break;
            case "YAxisStrokeThickness":
                this.lk(function (d) { return d.ea = _this.io; });
                break;
            case "XAxisExtent":
                this.li(function (d) { return d.extent = _this.hx; });
                break;
            case "YAxisExtent":
                this.lm(function (d) { return d.extent = _this.ie; });
                break;
            case "XAxisStrip":
                this.lh(function (d) { return d.hx = _this.mb; });
                break;
            case "YAxisStrip":
                this.lk(function (d) { return d.hx = _this.mi; });
                break;
            case "XAxisInverted":
                this.lh(function (d) { return d.bz = _this.gt; });
                break;
            case "YAxisInverted":
                this.lk(function (d) { return d.bz = _this.gu; });
                break;
            case "YAxisLabelLocation":
                this.lm(function (d) { return d.location = _this.gq; });
                break;
        }
    };
    Object.defineProperty(XYChart.prototype, "iz", {
        get: function () {
            return this.ix;
        },
        set: function (a) {
            var b = this.iz;
            if (a != b) {
                this.ix = a;
                this.fi("XAxisLabel", b, this.iz);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "i0", {
        get: function () {
            return this.iy;
        },
        set: function (a) {
            var b = this.i0;
            if (a != b) {
                this.iy = a;
                this.fi("YAxisLabel", b, this.i0);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "l9", {
        get: function () {
            return this.lv;
        },
        set: function (a) {
            var b = this.l9;
            if (a != b) {
                this.lv = a;
                this.fi("XAxisMajorStroke", b, this.l9);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "mg", {
        get: function () {
            return this.l2;
        },
        set: function (a) {
            var b = this.mg;
            if (a != b) {
                this.l2 = a;
                this.fi("YAxisMajorStroke", b, this.mg);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "h3", {
        get: function () {
            return this.g1;
        },
        set: function (a) {
            var b = this.h3;
            if (a != b) {
                this.g1 = a;
                this.fi("XAxisMajorStrokeThickness", b, this.h3);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "il", {
        get: function () {
            return this.hi;
        },
        set: function (a) {
            var b = this.il;
            if (a != b) {
                this.hi = a;
                this.fi("YAxisMajorStrokeThickness", b, this.il);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "h4", {
        get: function () {
            return this.g2;
        },
        set: function (a) {
            var b = this.h4;
            if (a != b) {
                this.g2 = a;
                this.fi("XAxisMinorStrokeThickness", b, this.h4);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "im", {
        get: function () {
            return this.hj;
        },
        set: function (a) {
            var b = this.im;
            if (a != b) {
                this.hj = a;
                this.fi("YAxisMinorStrokeThickness", b, this.im);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "mb", {
        get: function () {
            return this.lx;
        },
        set: function (a) {
            var b = this.mb;
            if (a != b) {
                this.lx = a;
                this.fi("XAxisStrip", b, this.mb);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "mi", {
        get: function () {
            return this.l4;
        },
        set: function (a) {
            var b = this.mi;
            if (a != b) {
                this.l4 = a;
                this.fi("YAxisStrip", b, this.mi);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "mc", {
        get: function () {
            return this.ly;
        },
        set: function (a) {
            var b = this.mc;
            if (a != b) {
                this.ly = a;
                this.fi("XAxisStroke", b, this.mc);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "mj", {
        get: function () {
            return this.l5;
        },
        set: function (a) {
            var b = this.mj;
            if (a != b) {
                this.l5 = a;
                this.fi("YAxisStroke", b, this.mj);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "h5", {
        get: function () {
            return this.g3;
        },
        set: function (a) {
            var b = this.h5;
            if (a != b) {
                this.g3 = a;
                this.fi("XAxisStrokeThickness", b, this.h5);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "io", {
        get: function () {
            return this.hk;
        },
        set: function (a) {
            var b = this.io;
            if (a != b) {
                this.hk = a;
                this.fi("YAxisStrokeThickness", b, this.io);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "h6", {
        get: function () {
            return this.g4;
        },
        set: function (a) {
            var b = this.h6;
            if (a != b) {
                this.g4 = a;
                this.fi("XAxisTickLength", b, this.h6);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ip", {
        get: function () {
            return this.hl;
        },
        set: function (a) {
            var b = this.ip;
            if (a != b) {
                this.hl = a;
                this.fi("YAxisTickLength", b, this.ip);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "md", {
        get: function () {
            return this.lz;
        },
        set: function (a) {
            var b = this.md;
            if (a != b) {
                this.lz = a;
                this.fi("XAxisTickStroke", b, this.md);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "mk", {
        get: function () {
            return this.l6;
        },
        set: function (a) {
            var b = this.mk;
            if (a != b) {
                this.l6 = a;
                this.fi("YAxisTickStroke", b, this.mk);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "h7", {
        get: function () {
            return this.g5;
        },
        set: function (a) {
            var b = this.h7;
            if (a != b) {
                this.g5 = a;
                this.fi("XAxisTickStrokeThickness", b, this.h7);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "iq", {
        get: function () {
            return this.hm;
        },
        set: function (a) {
            var b = this.iq;
            if (a != b) {
                this.hm = a;
                this.fi("YAxisTickStrokeThickness", b, this.iq);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "jx", {
        get: function () {
            return this.i2;
        },
        set: function (a) {
            var b = this.jx;
            if (a != b) {
                this.i2 = a;
                this.fi("XAxisTitle", b, this.jx);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "kz", {
        get: function () {
            return this.i5;
        },
        set: function (a) {
            var b = this.kz;
            if (a != b) {
                this.i5 = a;
                this.fi("YAxisTitle", b, this.kz);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ma", {
        get: function () {
            return this.lw;
        },
        set: function (a) {
            var b = this.ma;
            if (a != b) {
                this.lw = a;
                this.fi("XAxisMinorStroke", b, this.ma);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "mh", {
        get: function () {
            return this.l3;
        },
        set: function (a) {
            var b = this.mh;
            if (a != b) {
                this.l3 = a;
                this.fi("YAxisMinorStroke", b, this.mh);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "hy", {
        get: function () {
            return this.gw;
        },
        set: function (a) {
            var b = this.hy;
            if (a != b) {
                this.gw = a;
                this.fi("XAxisLabelAngle", b, this.hy);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ig", {
        get: function () {
            return this.hd;
        },
        set: function (a) {
            var b = this.ig;
            if (a != b) {
                this.hd = a;
                this.fi("YAxisLabelAngle", b, this.ig);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "hx", {
        get: function () {
            return this.gv;
        },
        set: function (a) {
            var b = this.hx;
            if (a != b) {
                this.gv = a;
                this.fi("XAxisExtent", b, this.hx);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ie", {
        get: function () {
            return this.hc;
        },
        set: function (a) {
            var b = this.ie;
            if (a != b) {
                this.hc = a;
                this.fi("YAxisExtent", b, this.ie);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "h8", {
        get: function () {
            return this.g6;
        },
        set: function (a) {
            var b = this.h8;
            if (a != b) {
                this.g6 = a;
                this.fi("XAxisTitleAngle", b, this.h8);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ir", {
        get: function () {
            return this.hn;
        },
        set: function (a) {
            var b = this.ir;
            if (a != b) {
                this.hn = a;
                this.fi("YAxisTitleAngle", b, this.ir);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "gt", {
        get: function () {
            return this.gr;
        },
        set: function (a) {
            var b = this.gt;
            if (a != b) {
                this.gr = a;
                this.fi("XAxisInverted", b, this.gt);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "gu", {
        get: function () {
            return this.gs;
        },
        set: function (a) {
            var b = this.gu;
            if (a != b) {
                this.gs = a;
                this.fi("YAxisInverted", b, this.gu);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ls", {
        get: function () {
            return this.lp;
        },
        set: function (a) {
            var b = this.ls;
            if (a != b) {
                this.lp = a;
                this.fi("XAxisTitleAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.ls));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "mr", {
        get: function () {
            return this.mo;
        },
        set: function (a) {
            var b = this.mr;
            if (a != b) {
                this.mo = a;
                this.fi("YAxisTitleAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.mr));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "lr", {
        get: function () {
            return this.lo;
        },
        set: function (a) {
            var b = this.lr;
            if (a != b) {
                this.lo = a;
                this.fi("XAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.lr));
            }
        },
        enumerable: true,
        configurable: true
    });
    XYChart.prototype.get_lt = function () {
        return this.lq;
    };
    XYChart.prototype.set_lt = function (a) {
        var b = this.lt;
        if (a != b) {
            this.lq = a;
            this.fi("YAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.lt));
        }
    };
    Object.defineProperty(XYChart.prototype, "lt", {
        get: function () {
            return this.get_lt();
        },
        set: function (a) {
            this.set_lt(a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "mp", {
        get: function () {
            return this.mm;
        },
        set: function (a) {
            var b = this.mp;
            if (a != b) {
                this.mm = a;
                this.fi("XAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.mp));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "mq", {
        get: function () {
            return this.mn;
        },
        set: function (a) {
            var b = this.mq;
            if (a != b) {
                this.mn = a;
                this.fi("YAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.mq));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "mu", {
        get: function () {
            return this.ms;
        },
        set: function (a) {
            var b = this.mu;
            if (a != b) {
                this.ms = a;
                this.fi("XAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.mu));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "mv", {
        get: function () {
            return this.mt;
        },
        set: function (a) {
            var b = this.mv;
            if (a != b) {
                this.mt = a;
                this.fi("YAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.mv));
            }
        },
        enumerable: true,
        configurable: true
    });
    XYChart.prototype.get_gq = function () {
        return this.gp;
    };
    XYChart.prototype.set_gq = function (a) {
        var b = this.gq;
        if (a != b) {
            this.gp = a;
            this.fi("YAxisLabelLocation", enumGetBox(AxisLabelsLocation_$type, b), enumGetBox(AxisLabelsLocation_$type, this.gq));
        }
    };
    Object.defineProperty(XYChart.prototype, "gq", {
        get: function () {
            return this.get_gq();
        },
        set: function (a) {
            this.set_gq(a);
        },
        enumerable: true,
        configurable: true
    });
    XYChart.$t = markType(XYChart, 'XYChart', DomainChart.$);
    return XYChart;
}(DomainChart));
export { XYChart };
//# sourceMappingURL=XYChart.js.map