/**
 * Provides data for IgxDataChartComponent mouse button related events.
*/
var /**
 * Provides data for IgxDataChartComponent mouse button related events.
*/
ChartCursorEventArgs = /** @class */ (function () {
    function ChartCursorEventArgs() {
    }
    Object.defineProperty(ChartCursorEventArgs.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    ChartCursorEventArgs.prototype.onImplementationCreated = function () {
    };
    ChartCursorEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(ChartCursorEventArgs.prototype, "item", {
        /**
         * Gets the ItemsSource item associated with the current event.
        */
        get: /**
             * Gets the ItemsSource item associated with the current event.
            */
        function () {
            return this.i.item;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ChartCursorEventArgs.prototype, "series", {
        /**
         * Gets the series associated with the current event.
        */
        get: /**
             * Gets the series associated with the current event.
            */
        function () {
            if (this.i.series == null) {
                return null;
            }
            return this.i.series.externalObject;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ChartCursorEventArgs.prototype, "seriesViewer", {
        /**
         * Gets the Chart associated with the current event.
        */
        get: /**
             * Gets the Chart associated with the current event.
            */
        function () {
            if (this.i.seriesViewer == null) {
                return null;
            }
            return this.i.seriesViewer.externalObject;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Provides a human readable expresion of the event arguments.
    
    */
    /**
         * Provides a human readable expresion of the event arguments.
        
        */
    ChartCursorEventArgs.prototype.toString = /**
         * Provides a human readable expresion of the event arguments.
        
        */
    function () {
        var iv = this.i.toString();
        return (iv);
    };
    return ChartCursorEventArgs;
}());
/**
 * Provides data for IgxDataChartComponent mouse button related events.
*/
export { ChartCursorEventArgs };
//# sourceMappingURL=igx-chart-cursor-event-args.js.map