/**
 * Represents a calculation strategy that takes in a column of values
 * and returns a resulting column of values.
*/
var /**
 * Represents a calculation strategy that takes in a column of values
 * and returns a resulting column of values.
*/
ColumnSupportingCalculation = /** @class */ (function () {
    function ColumnSupportingCalculation() {
    }
    Object.defineProperty(ColumnSupportingCalculation.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    ColumnSupportingCalculation.prototype.onImplementationCreated = function () {
    };
    ColumnSupportingCalculation.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    return ColumnSupportingCalculation;
}());
/**
 * Represents a calculation strategy that takes in a column of values
 * and returns a resulting column of values.
*/
export { ColumnSupportingCalculation };
//# sourceMappingURL=igx-column-supporting-calculation.js.map